#define max(x,y)    ((x) > (y)? (x) : (y))
#define min(x,y)    ((x) < (y)? (x) : (y))

#define SIMPLE 0
#define N_RANK 1

#define DEFAULT_S 100.00
#define DEFAULT_E 95.00
#define DEFAULT_r   0.10
#define DEFAULT_V   0.30
#define DEFAULT_T   1.00

#define DEFAULT_s 2000000
#define DEFAULT_t 10000

double C[3][DEFAULT_s + 1]; // TODO::change the space dimension
double F[2][DEFAULT_s + 1]; // TODO::change the space dimension

// int timeval_subtract(struct timeval *result, struct timeval *x, struct timeval *y);

// void print_usage( char *prog );


void computeCoeffs( double r, double V, double T, int ns, int nt);

int main( int argc, char *argv[ ] ) {
  // for timekeeping
  int ts_return = -1;
  //struct timeval start, end, result;
  double tdiff = 0.0;

  double S, E, r, V, T;
  int ns, nt;
  int i, t;
  double v, price1;

  S = DEFAULT_S;
  E = DEFAULT_E;
  r = DEFAULT_r;
  V = DEFAULT_V;
  T = DEFAULT_T;

  ns = DEFAULT_s;
  nt = DEFAULT_t;

  ns = ns + ( ns & 1 );
  double dS = 2.0 * S / ns;

  /* computeCoeffs( r, V, T, ns, nt ); */

  // initialize
  double V2 = V * V;
  double dt = T / nt;
  double r1 = 1.0 / ( 1.0 + r * dt );
  double r2 = dt / ( 1.0 + r * dt );
  int x;

  for ( x = 0; x <= ns; ++x ) {
    C[0][x] = r2 * 0.5 * x * ( - r + V2 * x );
    C[1][x] = r1 * ( 1 - V2 * x * x * dt );
    C[2][x] = r2 * 0.5 * x * ( r + V2 * x );
  }

  for ( i = 0; i <= ns; ++i )
    F[0][i] = max( 0.0, E - i * dS );

  F[1][0] = E;

  for (t = 0; t < nt; ++t ) {
    F[0][ns] = 0;
    F[1][ns] = 0;
  }

  for(t=0;t<nt;++t) 
    for(i=1;i<ns;++i) 
    {
      F[t][i] = C[0][i] * F[t][i-1] + C[1][i] * F[t%2][i] + C[2][i] * F[t][i+1];
    }

  price1 = F[nt%2][( ns >> 1 )];

  return 0;
}
