#include "head.h"

//This function modifies the mapping of a conflict edge; with the mapping as argument, if-else conditions are concatenated to modify the mapping 
void modify(char *temp, char *mapping, char *str)
{
	char *tok = NULL;
	strcpy(temp, "M := ");
	tok = strtok(mapping, "};"); 
	strcat(temp, tok);
	strcat(temp, "and ");
	strcat(temp, str);
	strcat(temp, " };M;");
	fileHandling(temp);
}

//This function populates the instance vector of an access
// Example : for(i = 1; i<= N; i++) A[i+1] = B[i+4];
/* iv = output i+1 when lhs mapping {i -> i + 1 | 1 <= i <= N} (in ISCC format) as tem is passed, output i + 4 when rhs mapping {i -> i+4 | 1 <= i <= N} (in ISCC format) as tem is passed, */
int populateIV(char **iv, char *tem)
{
	int i, k = 0;
	char temp[2*MAX];
	char *tok = NULL;
	char **arg = (char **)malloc(MIN * sizeof(char *));

	strcpy(temp, tem);
	tok = strtok(temp, ":");
	while(tok != NULL)
	{
		arg[k] = (char *)malloc(MAX * sizeof(char));
		strcpy(arg[k], tok);
		tok = strtok(NULL, ":");
		k++;
	}

	i = 0;
	while(arg[1][i] != '>')
		i++;
	i += 2;

	k = 0;
	while(arg[1][i] != ' ')
		temp[k++] = arg[1][i++];
	temp[k] = '\0';

	k = 0;
	tok = strtok(temp, "[]");
	while(tok != NULL)
	{
		arg[k] = (char *)malloc(MAX * sizeof(char));
		strcpy(arg[k], tok);
		tok = strtok(NULL, "[]");
		k++;
	}

	for(i=0; i<k; i++)
	{
		iv[i] = (char *)malloc(MIN * sizeof(char));
		strcpy(iv[i], arg[i]);
	}
	return i;
}

//This function creates a conflict edge between two conflicting accesses, it creates mapping also. temp = string for finding composition using iscc, idx = edge index
void createEdge(access *aarr, int acount, conf_edge *carr, access a1, access a2, char **dom, char *temp, int idx)
{
	carr[idx].a1 = a1;
	carr[idx].a2 = a2;

	if(a1.t == 0 && a2.t == 1)
		carr[idx].t = 0;
	else if(a1.t == 1 && a2.t == 0)
		carr[idx].t = 1;
	else if(a1.t == 1 && a2.t == 1)
		carr[idx].t = 2;

	isccComposition(aarr, acount, a1, a2, temp, dom);
	fileHandling(temp);
	strcpy(carr[idx].M, temp);
	carr[idx].flag = 1;
}

//This function assigns direction to Conflict Edges
int construct_cags(access *aarr, int acount, conf_edge *carr, statement *sarr, char **dom, int dcount)
{
	int i, j, k;
	char a, b;
	char it[2];
	char no[MIN];
	char str[MIN];
	char temp[3*MAX];
	char mapping[MAX];
	expTreeNode *p, *q;
	int ct1, ct2, smaller, flag, count = 0;

	char **iv1 = (char **)malloc(3 * sizeof(char *));
	char **iv2 = (char **)malloc(3 * sizeof(char *));

	for(i=0; i<acount-1; i++)
	{
		for(j=i+1; j<acount; j++)
		{
			isccInterSub(temp, aarr[i].R, aarr[j].R, "*");
			fileHandling(temp);
                        /* Whether the accesses conflict depends on the following condition */
			if((aarr[i].t == 1 || aarr[j].t == 1) && (aarr[i].s[1] != aarr[j].s[1]) && (strcmp(aarr[i].r -> n, aarr[j].r -> n) == 0) && strcmp(temp, "{  }") != 0)
			{//printf("%s %s %d %d\n", aarr[i].s, aarr[j].s, sarr[aarr[i].s[1] - '0' - 1].lis, sarr[aarr[j].s[1] - '0' - 1].lis);                
				if(sarr[aarr[i].st_idx - 1].lis == sarr[aarr[j].st_idx - 1].lis)
				{
                                        /* If two accesses occur in the same loops */
					flag = 0;
					for(k=0; k<dcount; k++)
					if(aarr[i].s[1] == dom[k][1] && aarr[i].s[2] == dom[k][2])
						break;

/* For access1, initial instance vector where the loop to statement mapping maps to is constructed */
					ct1 = populateIV(iv1, dom[k]);

					for(k=0; k<dcount; k++)
						if(aarr[j].s[1] == dom[k][1] && aarr[j].s[2] == dom[k][2])
							break;

/* For access2, initial instance vector where the loop to statement mapping maps to is constructed */
					ct2 = populateIV(iv2, dom[k]);
//printf("%d %d\n", ct1, ct2);
/* Finding whether the initial instance vectors conflict; flag = 1 means they conflict in both the directions, else they do not */
					if(ct1 != ct2)
						flag = 1;
					else
					{
						for(k=0; k<ct1; k++)
						{
							if(strcmp(iv1[k], iv2[k]) != 0)
							{
								flag = 1;
								break;
							}
						}
					}
//printf("k - %d flag - %d\n", k, flag);
					if(flag == 1)
					{
						if(ct1 == ct2)
						{
							p = aarr[i].r -> P[k];
							q = aarr[j].r -> P[k];

							a = p -> n[0];
							b = q -> n[0];
//printf("%c %c\n", a, b);
							if(a >= '0' && a <= '9' || b >= '0' && b <= '9')
							{
                                                                /* If there are no + and - signs alongwith the loop variables, then the code comes here */
								if(a >= '0' && a <= '9')
								{
									strcpy(no, p -> n);
									strcpy(it, q -> n);
								}
								else if(b >= '0' && b <= '9')
								{
									strcpy(no, q -> n);
									strcpy(it, p -> n);
								}
								else
									continue;

/* If the instance vectors conflict, then we create an conflict edge */
								createEdge(aarr, acount, carr, aarr[i], aarr[j], dom, temp, count);
								strcpy(str, it);
								strcat(str, ">");
								strcat(str, no);

								strcpy(mapping, carr[count].M);
/* The mapping is being modified (could not be remembered) */
								modify(carr[count].M, mapping, str);
								isccDomain(temp, carr[count].M);
								fileHandling(temp);
								if(strcmp(temp, "{  }") == 0)
									carr[count].flag = 0;

								count++;

								createEdge(aarr, acount, carr, aarr[j], aarr[i], dom, temp, count);
								strcpy(str, it);
								strcat(str, "'<");
								strcat(str, no);

								strcpy(mapping, carr[count].M);
								modify(carr[count].M, mapping, str);
								isccDomain(temp, carr[count].M);
								fileHandling(temp);
								if(strcmp(temp, "{  }") == 0)
									carr[count].flag = 0;

								count++;
							}
							else
							{
                                                                /* If there are + and - signs alongwith the loop variables, then the code comes here */
								if(a == '-')
								{
									if(b == '-' && (p -> P[1] -> n[0] < q -> P[1] -> n[0]))
										smaller = j;
									else
										smaller = i;
								}
								else if(a == '+')
								{
									if(b == '+' && (p -> P[1] -> n[0] < q -> P[1] -> n[0]))
										smaller = i;
									else
										smaller = j;
								}
								else
								{
									if(b == '-')
										smaller = j;
									else if(b == '+')
										smaller = i;
								}
								if(smaller == i)
								{
									createEdge(aarr, acount, carr, aarr[i], aarr[j], dom, temp, count);
									count++;
								}
								else
								{
									createEdge(aarr, acount, carr, aarr[j], aarr[i], dom, temp, count);
									count++;
								}
							}
						}
					}
					else
					{                       /* As flag ==0, edge is created in only one direction */
						createEdge(aarr, acount, carr, aarr[j], aarr[i], dom, temp, count);
						count++;
					}
				}
				else
				{ 		                    /* If two accesses occur in different loops */
					createEdge(aarr, acount, carr, aarr[j], aarr[i], dom, temp, count);
					count++;
				}
			}
		}
	}
	return count;
}
