#include "head.h"

void dfs(int s, int t, int *mat[], int count, int q[], int visited[], int *r)
{
	int i;
	for(i=0; i<count; i++)
  		if(mat[s][i] && !visited[i] && !visited[t])
                {
			q[++(*r)] = i;
  		        visited[i] = 1;
                        if(i != t)
  		            dfs(i, t, mat, count, q, visited, r);
                }

}

/* This function checks whether there is a path between s and t */
int isPath(int s, int t, int *mat[], int count, int *arr)
{
	int i, j, k, r = 0;
	int q[count], visited[count], p[count];

        printf("Path searched between s = %d and t = %d\n", s, t);
	for(i=0; i<count; i++)
 	{
  		q[i] = 0;
  		visited[i] = 0;
                arr[i] = -1;
 	}

        q[0] = s;
 	dfs(s, t, mat, count, q, visited, &r);

        p[0] = q[r];
        i = 1;
        for(k = r; k > 0;)
        {
            for(j = k - 1; ;j--)
            {
                if(mat[q[j]][q[k]] == 1)
                {
                    p[i] = q[j];
                    i++;
                    break;
                }
            }
            k = j;
        }

        for(k = 0; k < i; k++)
        {
            printf("sdutta : Reverse %d\n", p[k]);
        }

        j = 0;
 	if(visited[t])
	{
		for(k = i - 2; k > 0; k--)
		{
   		    arr[j] = p[k];
                    j++;
		}
                return 1;
	}
	else
		return 0;
}

/* Populating adjacency matrix for wait-signal graph */
void populateMatrix(access *aws, int count, statement *sarr, conf_edge *ews[], conf_edge *fsw[], int **mat)
{
	int i, j;
	for(i=0; i<count; i++)
		for(j=0; j<count; j++)
			mat[i][j] = 0;

	for(i=0; i<count; i++)
	{
		if(sarr[aws[i].st_idx - 1].t == 1)
		{
			for(j=0; j<count; j++)
				if(ews[i][j].flag == 1 && ews[i][j].dir == 1 && sarr[ews[i][j].a2.st_idx - 1].t == 2)
                                 {
					mat[i][j] = 1;
                                 }
		}
		else
		{
			for(j=0; j<count; j++)
				if(fsw[i][j].flag == 1 && fsw[i][j].dir == 1 && sarr[fsw[i][j].a2.st_idx - 1].t == 1)
                                {
					mat[i][j] = 1;
                                }
		}
	}
}

void printAllPaths(path *pws, int pcount)
{

}
void printAllCycles(path *pws, int pcount)
{
}
void findPaths(access *aws, int count, statement *sarr, conf_edge *ews[], conf_edge *fsw[], path *pws, int *pcount, path *cws, int *ccount)
{
	int i, j, k, l;
	int len, ind = 1;

	int *arr = (int *)malloc(count * sizeof(int));
	int **mat = (int **)malloc(count * sizeof(int *));
	for(i=0; i<count; i++)
		mat[i] = (int *)malloc(count * sizeof(int));

	char it[2];
	char str[4*MAX];
	char temp[4*MAX], temp_str[4*MAX];

/*aws = set of wait-signal accesses, count = number of wait-signal accesses, ews = set of conflict edges in wait-signal graph, 
  fsw = conflict edges due to control-flow, mat = adjacency matrix for wait-signal graph*/
	populateMatrix(aws, count, sarr, ews, fsw, mat);

	for(i=0; i<count; i++)
	{
/*While populating the statements in the parse table, statements are kept as s2w, s31 etc.*/
		if(sarr[aws[i].st_idx - 1].t == 1)
		{
/*If the statement is a wait statement*/
			for(j=0; j<count; j++)
			{
				if(sarr[aws[j].st_idx - 1].t == 2)
				{

/*Direct paths = only one pair of wait-signal accesses between two conflict accesses*/

/*finding direct paths BEGIN*/
					if(mat[i][j] == 1)
					{
/*pws = set of paths in the wait-signal graph, pcount = count of the number of paths in the wait-signal graph*/
						pws[*pcount].P = (access *)malloc(2 * sizeof(access));
						pws[*pcount].P[0] = aws[i];
						pws[*pcount].P[1] = aws[j];
                                                pws[*pcount].n = 2;
						strcpy(pws[*pcount].M, ews[i][j].M);
						(*pcount)++;						//increment the path count
/*finding direct paths END*/

/*finding direct cycles BEGIN*/
						if(mat[j][i] == 1)
						{
/*cws = set of cycles in the wait-signal graph, ccount = count of the number of cycles in the wait-signal graph*/
							cws[*ccount].P = (access *)malloc(3 * sizeof(access));
							cws[*ccount].P[0] = aws[i];
							cws[*ccount].P[1] = aws[j];
							cws[*ccount].P[2] = aws[i];
                                                        cws[*ccount].n = 3;
							strcpy(cws[*ccount].M, pws[(*pcount)-1].M);

							// parse(str, cws[*ccount].M, 0);
                                                        strcpy(temp, "M1 := ");
                                                        strcat(temp, cws[*ccount].M);
                                                        strcat(temp, "; M2 := M1^-1; M := M1 - M2; M;");
                                                        fileHandling(temp);                                               
                                                        strcpy(temp_str, "M1 := ");
                                                        strcat(temp_str, cws[*ccount].M);
                                                        strcat(temp_str, "; M2 := M1^-1; M3 := M2 - M1; M3;");
                                                        fileHandling(temp_str);                                                                

							// if(strcmp(str, " [i] -> [i] ") == 0)
                                                        if(strcmp(temp, "{  }") == 0 && strcmp(temp_str, "{  }") == 0)
							{
                                                                // sdutta : may be incorrect
                                                                endcputime = (double)clock();
                                                                //printf("Time taken %lf\n", (endcputime - startcputime)/CLOCKS_PER_SEC);
								printf("Deadlock Situation Exists2\n");
								exit(0);
							}
							(*ccount)++;						//increment the cycle count
							mat[j][i] = 0;
						}
/*finding direct cycles END*/
					}
				}
			}

			for(j=0; j<count; j++)
			{
				if(sarr[aws[j].st_idx - 1].t == 2)
				{
/*Indirect paths = more than one pair of wait-signal accesses between two conflict accesses*/

/*finding indirect paths BEGIN*/
					if(mat[i][j] == 0)
					{
						if(isPath(i, j, mat, count, arr))
						{
							len = 0;
							for(k=0; k<count; k++)
								if(arr[k] != -1)
									len++;
								else
									break;

							pws[*pcount].P = (access *)malloc((len + 2) * sizeof(access));
							pws[*pcount].P[0] = aws[i];
							for(k=0; k<len; k++)
								pws[*pcount].P[k+1] = aws[arr[k]];
								//pws[*pcount].P[k] = aws[arr[k]];
							pws[*pcount].P[len+1] = aws[j];
							pws[*pcount].n = len + 2;
							// pws[*pcount].n = len;


                                                        //printf("*****************************\n");
                                                        //for(k=0; k<len; k++)
	                                                //    printf("%s\n", pws[*pcount].P[k].s);
                                                        //printf("*****************************\n");

                                                        //len = len - 2;
							strcpy(temp, "M1 := ");
							strcat(temp, ews[i][arr[0]].M);
							strcat(temp, ";");

							for(k=1; k<len/2; k++)
							{
								strcat(temp, "M");
								sprintf(it, "%d", k+1);
								strcat(temp, it);
								strcat(temp, " := ");
								strcat(temp, ews[arr[k]][arr[k+1]].M);
								strcat(temp, ";");
							}

							strcat(temp, "M");
							sprintf(it, "%d", len);
							strcat(temp, it);
							strcat(temp, " := ");
							strcat(temp, ews[arr[len-1]][j].M);
							strcat(temp, ";");

							strcat(temp, "M := M1");
                                                        ind = 0;
							for(k=1; k<len/2; k++)
							{
								strcat(temp, "( M");
								sprintf(it, "%d", k+1);
								strcat(temp, it);
								ind++;
							}
							strcat(temp, "( M");
							sprintf(it, "%d", len);
							strcat(temp, it);
                                                        ind = ind + 1;

							for(k=0; k<ind; k++)
								strcat(temp, " )");
							strcat(temp, ";M;");
							fileHandling(temp);
							strcpy(pws[*pcount].M, temp);
							(*pcount)++;		//increment the path count
/*finding indirect paths END*/

/*finding indirect cycles BEGIN*/
							if(mat[j][i] == 1)
							{
								cws[*ccount].P = (access *)malloc((len + 3) * sizeof(access));
								cws[*ccount].P[0] = aws[i];
								for(k=0; k<len; k++)
									cws[*ccount].P[k+1] = aws[arr[k]];
								cws[*ccount].P[len+1] = aws[j];
								cws[*ccount].P[len+2] = aws[i];
								cws[*ccount].n = len + 3;
								strcpy(cws[*ccount].M, pws[(*pcount)-1].M);

                                                                strcpy(temp, "M1 := ");
                                                                strcat(temp, cws[*ccount].M);
                                                                strcat(temp, "; M2 := M1^-1; M := M1 - M2; M;");
                                                                fileHandling(temp);                                               
                                                                strcpy(temp_str, "M1 := ");
                                                                strcat(temp_str, cws[*ccount].M);
                                                                strcat(temp_str, "; M2 := M1^-1; M3 := M2 - M1; M3;");
                                                                fileHandling(temp_str);                                                                

								//parse(str, cws[*ccount].M, 0);
								//if(strcmp(str, " [i] -> [i] ") == 0)
                                                                if(strcmp(temp, "{  }") == 0 && strcmp(temp_str, "{  }") == 0)
								{
                                                                        // sdutta : correct
                                                                        endcputime = (double)clock();
                                                                        //printf("Time taken %lf\n", (endcputime - startcputime)/CLOCKS_PER_SEC);
									printf("Deadlock Situation Exists\n");		//deadlock exists when mapping of cycle is [i] -> [i]
									exit(0);
								}
								(*ccount)++;									//increment the cycle count
							}
/*finding indirect cycles END*/
						}
					}
				}
			}
		}
	}

        //printAllPaths(pws, pcount);
        //printAllCycles(pws, pcount);
	free(arr);
	free(mat);
}
