#include "head.h"

/*This function parses the input file line by line and call appropriate modules
depending upon the type of statements parsed*/
void parseInput(char* file_name, variable *varr, int *vcount, statement *sarr, int *scount, char **dom, int *dcount)
{
        int i, j, k = 0;
	int loopno = 0;		//loop number
	int lcount = 0;		//number of surrounding loops
	int ifcount = 0;	//number of if statements
	int elsecount = 0;	//number of else statements
        int hcount = 0;         //hierarchy count

	int flag[MIN];		//array to store integer 0(do) or 1(parallel do)
	char iter[MIN];		//array to store loop iterators
        int  hier[MAXNEST];     //loop hierarchy

	size_t nbytes = 1000;
	char *tok = NULL;
        char *str = (char *)malloc(nbytes + 1);
	char **arg = (char **)malloc(MAX * sizeof(char *));

	char **lower = (char **)malloc(MIN * sizeof(char *));				//array to store lower bound of loops
	char **upper = (char **)malloc(MIN * sizeof(char *));				//array to store upper bound of loops
	char **ifcond = (char **)malloc(MIN * sizeof(char *));				//array to store if conditions
	char **elsecond = (char **)malloc(MIN * sizeof(char *));			//array to store else conditions

        FILE *fp = fopen(file_name, "r");
       
	while(1)
        {
                fgets(str, nbytes, fp);  //library function to read input line by line
                printf("LINE : %s\n", str);
                str = strtok(str, ";\n");

                if(strcmp(str, "END") == 0)	//if END encountered, break the loop
                    break;

                j = 0;
                tok = strtok(str, ", {}");
                while(tok != NULL)
                {
                    arg[j] = (char *)malloc(MAX * sizeof(char));
                    strcpy(arg[j], tok);
                    tok = strtok(NULL, ", ");
                    j++;
                }


		if(strcmp(arg[0], "int") == 0)
			populateVariableTable(varr, vcount, arg, j);
		else if(strcmp(arg[0], "input") == 0 || strcmp(arg[0], "output") == 0)
			populateIO(varr, *vcount, arg, j);
		else if(strcmp(arg[0], "do") == 0 || strcmp(arg[0], "parallel") == 0)
		{
			k = 0; loopno++; hcount++; hier[hcount - 1] = loopno - k;
			populateDomain(arg, &lcount, lower, upper, iter, flag);
		}
		else if(strcmp(arg[0], "if") == 0 || strcmp(arg[0], "else") == 0)
			handleIfElse(ifcond, &ifcount, elsecond, &elsecount, arg);
		else if(strcmp(arg[0], "end") == 0)
		{
			if(strcmp(arg[1], "do") == 0 || strcmp(arg[1], "parallel") == 0)
                         {
				k++, lcount--; hcount--;
                         }
			else if(strcmp(arg[1], "if") == 0)
			{
				if(elsecount == 0)
					ifcount--;
				else
					elsecount--;
			}
		}
		else
			populateStatementTable(varr, *vcount, sarr, scount, arg, lcount, ifcond, 
                                               ifcount, elsecond, elsecount, dom, dcount, lower, 
                                               upper, iter, flag, loopno, k, hcount, hier);
	}
        fclose(fp);
	free(lower);
	free(upper);
	free(ifcond);
	free(elsecond);
}
