#include "head.h"

/*This function is called recursively by the populateAccessTable function in
order to populate access table*/
void patRecur(expTreeNode *root, statement *sarr, access *aarr, char **dom, int *idx, int i, int *j, variable *varr, int vcount)
{
	if(!root)
		return;

	int k;
	char temp[3*MAX], str[MAX], temp_str[MAX];

	if(root -> t == 1)
	{
	/*      aarr[*idx].s[0] = 'S';
		aarr[*idx].s[1] = (char)(((int)'0')+i+1);
		if(sarr[i].t != 2)
			aarr[*idx].s[2] = (char)(((int)'0')+(*j)+1);
		else
			aarr[*idx].s[2] = 'W';
		aarr[*idx].s[3] = '\0';*/
		aarr[*idx].t = 0;
		strcpy(str, "S");
                snprintf(temp_str, 3*MAX, "%d", i+1);
                strcat(str, temp_str);
                strcpy(aarr[*idx].s, str);
                if(sarr[i].t == 0)
                {
                    snprintf(temp_str, 3*MAX, "%d", (*j) + 1);
                    strcat(aarr[*idx].s, temp_str);
                }
                else 
                {
                    strcat(aarr[*idx].s, "W");
                }
		strcpy(temp, dom[*idx]);
	        aarr[*idx].st_idx = i+1;
		strcat(temp, "S := ran ");
		strcat(temp, aarr[*idx].s);
		strcat(temp, ";S;");

		fileHandling(temp);
		strcpy(aarr[*idx].R, temp);
		aarr[*idx].r = (expTreeNode *)malloc(sizeof(expTreeNode));
		aarr[*idx].r = root;
                for(k = 0; k < vcount; k++)
                {
                    if(strcmp(varr[k].n, aarr[*idx].r->n) == 0)
                    {
                        aarr[*idx].var_idx = k;
                        break;
                    }
                }
		(*idx)++;
		(*j)++;
	}
	else if(root -> t == 2)
	{
		for(k=0; k<(root -> r); k++)
			patRecur(root -> P[k], sarr, aarr, dom, idx, i, j, varr, vcount);
	}
        else
        {
                /* Scalar and functions are strictly not handled */
        }
}

/*This function populates all the accesses present in the program by recursively
calling the patRecur function*/
int populateAccessTable(access *aarr, statement *sarr, int scount, char **dom, variable *varr, int vcount)
{
	int i, j, k, idx = 0;
	char temp[3*MAX], str[MAX], temp_str[MAX];

	for(i=0; i<scount; i++)
	{
		if(sarr[i].t == 0 || sarr[i].t == 2)
		{
                        // Wait or assignment statements
			/*aarr[idx].s[0] = 'S';
			aarr[idx].s[1] = (char)(((int)'0')+i+1);
			if(sarr[i].t != 1)
				aarr[idx].s[2] = 'L';
			else
				aarr[idx].s[2] = 'S';
			aarr[idx].s[3] = '\0';*/
                        strcpy(str, "S");
                        snprintf(temp_str, 3*MAX, "%d", i+1);
                        strcat(str, temp_str);
                        if(sarr[i].t == 0)
		            strcat(str, "L");
			else
			    strcat(str, "S");
                        strcpy(aarr[idx].s, str);
			aarr[idx].t = 1;
			aarr[idx].st_idx = i+1;

			strcpy(temp, dom[idx]);
			strcat(temp, "S := ran ");
			strcat(temp, aarr[idx].s);
			strcat(temp, ";S;");
			fileHandling(temp);
			strcpy(aarr[idx].R, temp);
			aarr[idx].r = (expTreeNode *)malloc(sizeof(expTreeNode));
			aarr[idx].r = sarr[i].L -> P;
                        for(k = 0; k < vcount; k++)
                        {
                            if(strcmp(varr[k].n, aarr[idx].r->n) == 0)
                            {
                                aarr[idx].var_idx = k;
                                break;
                            }
                        }
			idx++;
		}

		j = 0;
		if(sarr[i].t == 0 || sarr[i].t == 1)
                {
                        // Signal or assignment statements
			patRecur(sarr[i].T, sarr, aarr, dom, &idx, i, &j, varr, vcount);
                }
	}
	return idx;
}

//This function populates S<alpha> fields of all the read accesses and wait statements present in the program
void populateReadAccess(variable *varr, int vcount, statement *sarr, access *aarr, int acount, conf_edge *carr, int ecount, char **dom, int dcount)
{
	int i, j, k, l, m, n, p;
	int idx, len;

	char temp_dom[3*MAX], *pch, str[3*MAX];
	char temp[3*MAX], temp_str[3*MAX], minus[3*MAX];

	access tem;
	access *tempaarr = (access *)malloc(acount * sizeof(access));
	access *tempaarr1 = (access *)malloc(acount * sizeof(access));
	
        for(i = 0; i < dcount; i++)
        {
            strcpy(temp_str, dom[i]);
            pch = strtok(temp_str, ":=");
        }

	for(k=0; k<acount; k++)
	{
		if(aarr[k].t == 0) // read access
		{
			for(i=0; i<vcount; i++)
			{
				if(strcmp(aarr[k].r -> n, varr[i].n) == 0 && varr[i].io != 1) // read access to a temp array
				{
					len = 0;
					idx = 0;
					for(p=0; p<ecount; p++)
						if((strcmp(carr[p].a1.s, aarr[k].s) == 0) && carr[p].t == 0 && carr[p].flag == 1)
                                                {
							tempaarr[len++] = carr[p].a2;
                                                }

                                        /* tempaarr contains all the write accesses which write into the array 
                                           corresponding to the read access */
					aarr[k].S = (set *)calloc(len, sizeof(set));

					if(sarr[aarr[k].st_idx - 1].t == 1) //read access corresponding to wait statement
					{
						for(l=0; l<len-1; l++)
						{
							isccInterSub(temp, tempaarr[l].R, tempaarr[l+1].R, "*");
							fileHandling(temp);
							if(strcmp(temp, "{  }") != 0)
							{
								printf("Dependence Graph can not be constructed\n");
								exit(0);
							}
						}
					}
					else    //read access corresponding to non input array
					{

						/*Perform ordering relation for WAW dependences */
						/*for(l=0; l<len-1; l++)
						{
							for(i=0; i<ecount; i++)
							{
								if((strcmp(carr[i].a1.s, tempaarr[l+1].s) == 0) && 
                                                                (strcmp(carr[i].a2.s, tempaarr[l].s) == 0) && carr[i].t == 2)
								{
									tem = tempaarr[l];
									tempaarr[l] = tempaarr[l+1];
									tempaarr[l+1] = tem;
								}
							}
						}*/
                                                for(m = 0; m < len-1; m++)
						{
                                                    for(n = m + 1; n < len; n++)
                                                    {
							for(p=0; p<ecount; p++)
							{
								if((strcmp(carr[p].a1.s, tempaarr[m].s) == 0) && 
                                                                (strcmp(carr[p].a2.s, tempaarr[n].s) == 0) && carr[p].t == 2)
								{
									tem = tempaarr[m];
									tempaarr[m] = tempaarr[n];
									tempaarr[n] = tem;
								}
							}
                                                    }
						}
                                                for(p = 0; p < len/2; p++)
                                                {
                                                    tem = tempaarr[p];
                                                    tempaarr[p] = tempaarr[len - p - 1];
                                                    tempaarr[len - p - 1] = tem;
                                                }
                                                
					}

                                        for(n = 0; n < dcount; n++)
                                        {
                                            strcpy(temp_str, dom[n]);
                                            pch = strtok(temp_str, " ");
                                            if(strcmp(pch, aarr[k].s) == 0) break;
                                        }
					//strcpy(temp_dom, aarr[k].R);
                                        strcpy(temp_dom, dom[n]);
					sprintf(str, "S := dom %s; S;", aarr[k].s);
                                        strcat(temp_dom, str);
                                        fileHandling(temp_dom);
					for(l=0; l<len; l++)
					{
                                                for(m = 0; m < ecount; m++)
                                                {
                                                    if(strcmp(carr[m].a1.s, aarr[k].s) == 0 && strcmp(carr[m].a2.s, tempaarr[l].s) == 0)
                                                        break;
                                                }
						//isccInterSub(temp, temp_dom, tempaarr[l].R, "*");
                                                sprintf(temp_str, "M := %s; S := dom M; S;", carr[m].M);
                                                fileHandling(temp_str);
						//isccInterSub(temp, temp_dom, tempaarr[l].R, "*");
						isccInterSub(temp, temp_dom, temp_str, "*");
						//isccInterSub(temp, temp_dom, carr[m].M, "*");
						fileHandling(temp);
						// if(strcmp(temp_dom, "{  }") != 0 && strcmp(temp, "{  }") != 0)
						if(strcmp(temp, "{  }") != 0)
						{
                                                        /* Populating statement number and domains */
							strcpy(aarr[k].S[idx].s, tempaarr[l].s);
							strcpy(aarr[k].S[idx].D, temp);

							isccInterSub(minus, temp_dom, temp, "-");
							fileHandling(minus);
							strcpy(temp_dom, minus);
							idx++;
						}
						else
						{
							for(p=0; p<ecount; p++)
								if((strcmp(carr[p].a1.s, aarr[k].s) == 0) && 
                                                          (strcmp(carr[p].a2.s, tempaarr[l].s) == 0) && carr[p].t == 0 && carr[p].flag == 1)
									carr[p].flag = 0; // not included
						}
					}
                                        // checking whether an access has some unintialized part
                                        /*if(strcmp(temp_dom, "{  }") != 0)
                                        {
                                                aarr[k].uninit_flag = 1;
                                                strcpy(aarr[k].uninit_R, temp_dom);
                                        }
                                        else
                                        {
                                                aarr[k].uninit_flag = 0;
                                                strcpy(aarr[k].uninit_R, "");
                                        }*/
					break;
				}
			}
		}
	}
	free(tempaarr);
}

//This function populates all the write accesses present in the program, it populates the the S<alpha> fields of all the write accesses writing onto the output array and for signal statements
void populateWriteAccess(variable *varr, int vcount, statement *sarr, access *aarr, int acount, conf_edge *carr, int ecount)
{
	int i, j, k, l;
	int len;
	char it[2];
	
	char dom[MAX];
	char temp[3*MAX];

	access tem;
	access *tempaarr = (access *)malloc(acount * sizeof(access));

	for(i=0; i<vcount; i++)
	{
		if(varr[i].io == 2)						//write access corresponding to output array
		{
			len = 0;
			for(k=0; k<acount; k++)
				if(strcmp(aarr[k].r -> n, varr[i].n) == 0 && aarr[k].t == 1)
					tempaarr[len++] = aarr[k];

                        /* tempaarr contains all the write accesses which write into the output array */
			/*Perform ordering relation*/
			for(l=0; l<len-1; l++)
			{
				for(i=0; i<ecount; i++)
				{
					if((strcmp(carr[i].a1.s, tempaarr[l+1].s) == 0) && (strcmp(carr[i].a2.s, tempaarr[l].s) == 0) && carr[i].t == 2)
					{
						tem = tempaarr[l];
						tempaarr[l] = tempaarr[l+1];
						tempaarr[l+1] = tem;
					}
				}
			}

			memset(dom, '\0', sizeof(dom));
			for(l=0; l<len; l++)
			{
				strcat(dom, "S");
				sprintf(it, "%d", l+1);
				strcat(dom, it);
				strcat(dom, " := ");
				strcat(dom, tempaarr[l].R);
				strcat(dom, ";");
			}

			strcat(dom, "S := S");
			for(l=0; l<len-1; l++)
			{
				sprintf(it, "%d", l+1);
				strcat(dom, it);
				strcat(dom, " + S");
			}
			sprintf(it, "%d", l+1);
			strcat(dom, it);
			strcat(dom, ";S;");

			fileHandling(dom);
			for(l=0; l<len; l++)
			{
				for(k=0; k<acount; k++)
				{
					if(strcmp(aarr[k].s, tempaarr[l].s) == 0)
					{
                                                /* The statement numbers and domains for S<alpha> are populated */
						aarr[k].S = (set *)malloc(sizeof(set));
						strcpy(aarr[k].S[0].s, aarr[k].s);

						isccInterSub(temp, dom, aarr[k].R, "*");
						fileHandling(temp);
						strcpy(aarr[k].S[0].D, temp);

						isccInterSub(temp, dom, aarr[k].S[0].D, "-");
						fileHandling(temp);
						strcpy(dom, temp);
					}
				}
			}
		}
	}

	for(k=0; k<acount; k++)
	{
		if(sarr[aarr[k].st_idx -1].t == 2)					//write access corresponding to signal statement
		{
			len = 0;
			for(j=0; j<acount; j++)
			{
				if(strcmp(aarr[k].r -> n, aarr[j].r -> n) == 0 && sarr[aarr[j].st_idx - 1].t == 1)
					tempaarr[len++] = aarr[j];

				for(l=0; l<len-1; l++)
				{
					isccInterSub(temp, tempaarr[l].R, tempaarr[l+1].R, "*");
					fileHandling(temp);					
					if(strcmp(temp, "{  }") != 0)
					{
						printf("Dependence Graph can not be constructed\n");
						exit(0);
					}
				}

				for(l=0; l<len; l++)
				{
					aarr[k].S = (set *)malloc(sizeof(set));
					strcpy(aarr[k].S[0].s, tempaarr[l].s);
					strcpy(aarr[k].S[0].D, tempaarr[l].R);
				}
			}
		}
	}
	free(tempaarr);
}
