#include "head.h"

void pre(expTreeNode *root, char *str)
{
	if(root == NULL)
		return;

	strcat(str, root -> n);
	int i;
	for(i=0; i<(root -> r); i++)
		pre(root -> P[i], str);
}

//This function determines the direction of conflict edge
/* ind = indicator to tell whether the direction can be ascertained or not, idx = index of the edge */
void fixDirection(conf_edge *carr, int ind, int idx)
{
	if(ind == 0)
		carr[idx].dir = 1;
	else
		carr[idx].dir = 0;
}

//This function checks for the non-determinacy of program
void checkDeterminacy(conf_edge *carr, int ecount)
{
	int i;
	for(i=0; i<ecount; i++)
	{
		if(carr[i].dir == 0)
		{
                        endcputime = (double)clock();
                        printf("Time taken %lf\n", (endcputime - startcputime)/CLOCKS_PER_SEC);
			printf("Non-determinate Program\n");
			exit(0);
		}
	}
}

void extract_var(char *pch_str, char **arr, int *m, int *exp, int same_st)
{
    int i, k, flag = 0;
    *m = 0;
    for(i = 0; i < strlen(pch_str); i++)
    {
        if(pch_str[i] == '[')
        {
            arr[*m] = (char *)malloc(MAX * sizeof(char));
            flag = 1;
            k = 0;
            exp[*m] = 0;
        }
        else if(pch_str[i] == ']')
        {
            flag = 0;
            arr[*m][k] = '\0';
            if(k != 0)
            {
                (*m)++;
            }
        }
        else
        {
            if(flag == 1)
            {
                if((pch_str[i] >= 'a' && pch_str[i] <= 'z') || pch_str[i] == 39)
                {
                    arr[*m][k] = pch_str[i];
                    k++;
                }
                if(pch_str[i] == '*' || pch_str[i] == '/' || pch_str[i] == '+' || pch_str[i] == '-' || (same_st && pch_str[i] == 39))
                {
                    exp[*m] = 1;
                }
            }
        }
    }
}
/*void identifyVars(char **lhs, int m1, char **varLhs, int *countLhs)
{
    int i, j;

    printf("Begin identifyVars\n");
    for(i = 0; i < m1; i++)
    {
        countLhs[i] = 0;
        varLhs[i] = (char *)malloc(sizeof(char)*MAX);
        printf("lhs[i] %s\n", lhs[i]);
        for(j = 0; j < strlen(lhs[i]); j++)
        {
            if(lhs[i][j] >= 'a' && lhs[i][j] <= 'z')
            {
                varLhs[i][countLhs[i]] = lhs[i][j];
                countLhs[i]++;
            }
        }
        printf("LHS %s countLhs %d\n", lhs[i], countLhs[i]);
    }
    printf("End identifyVars\n");
    // return countLhs;
}
*/

void extract_upper_bound(char *oVar, char *ub, char *dom)
{
    int i, l, k;
    char rhs[3*MAX], in_rhs[3*MAX], *pch, name[MAX], var, str[MAX];
    extractStr(dom, "{", "}", rhs); 
    strcat(rhs, "}");
    extractStr(rhs, ":", "}", in_rhs); 
    strcpy(name, oVar);
    sprintf(str, "%s <= ", name);
    pch = strstr(in_rhs, str);
    pch = pch + strlen(str);
    k = 0;
    while(pch[k] >= '0' && pch[k] <= '9')
    {
        ub[k] = pch[k];
        k++;
    }  
    ub[k] = '\0';
}

void edit_mapping(access a1, access a2, char** lhs, int m1, char **rhs, int m2, char *mapping, char *revised_map)
{
    int i, j, k, l, m, b, idx, ineq[MAX], val, count;
    char init_str[3*MAX], str[3*MAX], *pch, range[MAX][MAX], ub[MAX];

    count = 0;
    if(m1 > m2)
    {
        m = m2;
        b = m1;
    }
    else
    {
        m = m1;
        b = m2;
    }
    for(i = 0; i < m; i++)
    {
        if(strcmp(lhs[i], rhs[i]))
        {
            ineq[i] = 1;
            count++;
        }
        else
        {
            ineq[i] = 0;
        }
    }
    for(i = m; i < b; i++)
    {
        ineq[i] = 1;
    }

    for(i = 0; i < strlen(mapping); i++)
    {
        if(mapping[i] != '}')
        {
            revised_map[i] = mapping[i];
        }
        else
        {
            break;
        }
    }
    revised_map[i] = '\0';

    
    for(i = 0; i < m; i++)
    {
        if(ineq[i] == 1)
        {
            extract_upper_bound(rhs[i], ub, revised_map);
            val = atoi(ub) - 1;
            sprintf(str, "and ((%s = %s + 1 and %s <= %d)", lhs[i], rhs[i], rhs[i], val);
            strcat(revised_map, str);
            count--;
            if(count >= 1)
            {
                sprintf(str, "or (%s = %s))", lhs[i], rhs[i]);
                strcat(revised_map, str);
            }
            else
            {
                strcat(revised_map, ")");
            }
        }
    }
    strcat(revised_map, " } ");

/*    extractStr(revised_map, "{", ":", init_str);
    extractStr(revised_map, ":", "}", str);
    k = 0;
    pch = strtok(str, "and");
    while(pch != NULL)
    {
        strcpy(range[k], pch);
        k++;
        pch = strtok(NULL, "and");
    }

    for(i = 0; i < m1; i++)
    {
        if(ineq[i] == 1)
        {
            sprintf(str, "%s <=", rhs[i]);
            for(j = 0; j < k; j++)
            {
                if(strstr(range[j], str))
                {
                    for(l = 0; l < strlen(range[j]) - 1; l++)
                    {
                        if(range[j][l] == '<' && range[j][l+1] == '=')
                        {
                            break;
                        }
                    }
                    l = l + 2;
                    idx = 0;
                    for(m = l; m < strlen(range[j]); m++)
                    {
                       if(range[j][m] >= '0' && range[j][m] <= '9')
                       {
                           ub[idx] = range[j][m];
                           idx++;
                       }
                    }
                    ub[idx] = '\0';
                    val = atoi(ub);
                    val = val - 1;
                    sprintf(str, "%d", val);
                    range[j][l] = ' ';
                    l++;
                    for(m = 0; m < strlen(str); m++)
                    {
                        range[j][l] = str[m];
                        l++;
                    }
                    range[j][l] = ' ';
                    l++;
                    range[j][l] = '\0';
                }
            }
        }
    }

    strcpy(revised_map, " { ");
    strcat(revised_map, init_str);
    strcat(revised_map, " : ");
    for(i = 0; i < k - 1; i++)
    {
        strcat(revised_map, range[i]);
        strcat(revised_map, "and");
    }
    strcat(revised_map, range[k - 1]);
    strcat(revised_map, " } ");*/
}

void add_edge(access a1, access a2, char** lhs, int m1, char **rhs, int m2, int *exp1, int *exp2, conf_edge *carr, int *count, char *mapping, statement *sarr)
{
    int i, j, dir_flag, flag;
    char revised_mapping[3*MAX];

    if(m1 == m2)
    {
        edit_mapping(a1, a2, lhs, m1, rhs, m2, mapping, revised_mapping);
        strcpy(carr[*count].M, revised_mapping);
    
        carr[*count].a1 = a1;
        carr[*count].a2 = a2;
        if(a1.t == 0 && a2.t == 1)
        {
            carr[*count].t = 0;
        }
        else if(a1.t == 1 && a2.t == 0)
        {
            carr[*count].t = 1; 
        }
        else if(a1.t == 1 && a2.t == 1)
        {
            carr[*count].t = 2;
        }
        else
        {
        }
        carr[*count].flag = 1;

        dir_flag = 0;
        flag = 0;
        for(i = 0; i < m1; i++)
        {
            for(j = 0; j < m2; j++)
            {
                if(sarr[a1.st_idx - 1].lhier[i] != -1 && sarr[a2.st_idx - 1].lhier[j] != -1 && 
                   sarr[a1.st_idx - 1].lhier[i] == sarr[a2.st_idx - 1].lhier[j] && sarr[a1.st_idx - 1].o[i] == 1)            
                {
                    if((exp1[i] == 0 && exp2[j] == 1) || (exp1[i] == 1 && exp2[j] == 0) || strcmp(lhs[i], rhs[j]))
                    {
                        dir_flag = 1;
                        flag = 1;
                        break;
                    }
                }
                else if(sarr[a1.st_idx - 1].lhier[i] != -1 && sarr[a2.st_idx - 1].lhier[j] != -1 &&
                   sarr[a1.st_idx - 1].lhier[i] == sarr[a2.st_idx - 1].lhier[j] && sarr[a1.st_idx - 1].o[i] == 0)
                {
                    if((exp1[i] == 0 && exp2[j] == 1) || (exp1[i] == 1 && exp2[j] == 0) || strcmp(lhs[i], rhs[j]))
                    {
                        dir_flag = 0;
                        flag = 1;
                        break;
                    }
                }
            }
            if(flag == 1)
                break;
        }
        if(dir_flag == 0)
            carr[*count].dir = 1;
        else
            carr[*count].dir = 0;
        (*count)++;
    }
}

void replaceCommaWithBrackets(char *init_str, char *final_str)
{
    int i, j;

    j = 0;
    for(i = 0; i < strlen(init_str); i++)
    {
        if(init_str[i] != ',')
        {
            final_str[j] = init_str[i];
            j++;
        }
        else
        {
            final_str[j] = ']';
            final_str[j+1] = '[';
            j = j + 2;
        }
    }
    final_str[j] = '\0';
}

void addNSAEdge(access a1, access a2, char *dom1, char *dom2, conf_edge *carr, int *count, int ind, statement *sarr, int same_st)
{
    int i, j, k, flag[MAX], m1, m2, exp1[MAX], exp2[MAX];
    char str[3*MAX], str1[3*MAX], map_dom[3*MAX], name_token[MAX], pch_str[MIN][3*MAX], **lhs, **rhs, temp_str[3*MAX];
    
    lhs = (char **)malloc(MAX * sizeof(char *));
    rhs = (char **)malloc(MAX * sizeof(char *));
    strcpy(str, dom1);
    strcpy(name_token, a2.s);
    strcat(name_token, "1");
    extractStr(dom2, "{", "}", map_dom);
    sprintf(str1, "%s := { %s }; %sI := %s^-1; M :=%sI(%s); M;", name_token, map_dom, name_token, name_token, name_token, a1.s);
    strcat(str, str1);
    // Access a1 and access a2 are in conflict
    fileHandling(str);
    replaceCommaWithBrackets(str, temp_str);
    strcpy(str, temp_str);
    extractStr(str, "{", "->", pch_str[0]);
    extractStr(str, "->", ":", pch_str[1]);
    extract_var(pch_str[0], lhs, &m1, exp1, same_st);
    extract_var(pch_str[1], rhs, &m2, exp2, same_st);
    for(i = 0; i < m2; i++)
    {
        if(exp2[i] == 1)
        {
            break;
        }
    }
    if((i != m2) || (ind == 0))
    {
        add_edge(a1, a2, lhs, m1, rhs, m2, exp1, exp2, carr, count, str, sarr);
    }
    else
    {
        add_edge(a1, a2, lhs, m1, rhs, m2, exp1, exp2, carr, count, str, sarr);
        strcpy(str, dom2);
        strcpy(name_token, a1.s);
        strcat(name_token, "1");
        extractStr(dom1, "{", "}", map_dom);
        sprintf(str1, "%s := { %s }; %sI := %s^-1; M :=%sI(%s); M;", name_token, map_dom, name_token, name_token, name_token, a2.s);
        strcat(str, str1);
        fileHandling(str);
        replaceCommaWithBrackets(str, temp_str);
        strcpy(str, temp_str);
        extractStr(str, "{", "->", pch_str[0]);
        extractStr(str, "->", ":", pch_str[1]);
        extract_var(pch_str[0], lhs, &m1, exp1, same_st);
        extract_var(pch_str[1], rhs, &m2, exp2, same_st);
        add_edge(a2, a1, lhs, m1, rhs, m2, exp1, exp2, carr, count, str, sarr);
    }
}

//void addWAWedge(access a, char *dom, char **lhs, int m1, char **rhs, int m2, conf_edge *carr, int *count, char **oddVar, int *k)
//{
//    char flag[MAX], *pch, temp_str[MAX], temp_dom[MAX];
//    char mapping[3*MAX], str[3*MAX];
//    int  i, j;

//    printf("Begin addWAWedge\n");
/*    *k = 0;
    for(i = 0; i < m1; i++)
    {
        printf("i %d\n", i);
        for(j = 0; j < m2; j++)
        {
            if(strcmp(lhs[i], rhs[j]) == 0)
            {
                break;
            }
        }
        if(j == m2)
        {
            strcpy(oddVar[*k], lhs[i]);
            printf("i %d Oddvar %s\n", i, oddVar[*k]);
            (*k)++;
        }
    }

    strcpy(mapping, "{ ");
    for(i = 0; i < m1; i++)
    {
        flag[i] = 0;
        sprintf(str, "[%s]", lhs[i]);
        strcat(mapping, str);
        for(j = 0; j < *k; j++)
        {
            if(strcmp(lhs[i], oddVar[j]) == 0)
            {
                flag[i] = 1;
            }
        }
    }
    strcat(mapping, " -> ");
    for(i = 0; i < m1; i++)
    {
        if(flag[i] == 1)
        {
            sprintf(str, "[%s - 1]", lhs[i]);
            strcat(mapping, str);
        }
        else
        {
            sprintf(str, "[%s]", lhs[i]);
            strcat(mapping, str);
        }
    }
    printf("mapping %s\n", mapping);
    strcpy(temp_dom, dom);
    pch = strtok (temp_dom, ":");
    pch = strtok (NULL, ":");
    pch = strtok (NULL, ":");
    printf("pch %s\n", pch);
    strcpy(temp_str, pch);
    //extractStr(dom, ": ", "}", str);
    strcat(mapping, ":");
    printf("mapping %s\n", mapping);
    strcat(mapping, temp_str);
    // strcat(mapping, "}");
    printf("Created mapping %s\n", mapping);

    carr[*count].a1 = a; 
    carr[*count].a2 = a; 
    carr[*count].t = 2; 
    strcpy(carr[*count].M, mapping);
    strcpy(carr[*count].included_M, mapping);
    carr[*count].flag = 1;
    carr[*count].dir = 1;
    (*count)++;
*/ 
//    printf("End addWAWedge\n");
//    addNSAEdge(a, a, dom, dom, carr, count);
//}



/*void adjust_domain(char *oVar, char *ub, char *dom, char *ndom)
{
    int i, j, l, k, flag;
    char rhs[3*MAX], *pch, name[MAX], range[MAX][MAX], adj_dom[3*MAX], temp_dom[MAX], temp_str[3*MAX];

    printf("Dom %s oddVar %c\n", dom, oVar); 
    extractStr(dom, "{", "}", rhs); 
    strcat(rhs, "}");
    extractStr(rhs, ":", "}", rhs); 
    printf("rhs %s\n", rhs); 
    strcpy(name, oVar);

    sprintf(temp_dom, "[%s]", oVar);
    for(i = 0; i < strlen(dom); i++)
    {
        if(dom[i] == ':' && dom[i + 1] == ' ')
        {
            break;
        }
        else
        {
            ndom[i] = dom[i];
        }
    }
    ndom[i] = '\0';

    j = 0;
    strcpy(temp_dom, ndom);
    printf("temp_dom %s\n", temp_dom);
    for(i = 0; i < strlen(temp_dom);)
    {
        // if(temp_dom[i] == '[' && temp_dom[i + 1] == oVar && temp_dom[i + 2] == ']')
        if(temp_dom[i] == '[')
        {
            for(k = 0; k < strlen(oVar); k++)
            {
                if(temp_dom[i + k] != oVar[k])
                {
                    break;
                }
            }

            if(k == strlen(oVar) && temp_dom[i + k] == ']')
            {
                ndom[j] = '[';
                j++;
                for(l = 0; l < strlen(ub); l++, j++)
                {
                    ndom[j] = ub[l];
                }
                ndom[j] = ']';
                j++;
                i = i + strlen(oVar) + 1;
            }
            else
            {
                ndom[j] = temp_dom[i];
                j++;
                i++;
            }
        }
    }
    ndom[j] = '\0';
    strcat(ndom, " : ");
    printf("NDOM %s\n", ndom);
    
    k = 0;
    pch = strtok(rhs, "and");*/
    /* walk through other tokens */
/*    while(pch != NULL ) 
    {
        printf( " %s\n", pch);
        if(!strstr(pch, name))
        {
            strcpy(range[k], pch);
            k++;
        }
        pch = strtok(NULL, "and");
    } 
    for(i = 0; i < k - 1; i++)
    {
        strcat(ndom, range[i]);
        strcat(ndom, " and ");
    }
    strcat(ndom, range[k - 1]);
    strcat(ndom, "};");
    printf("ORIG DOM %s strlen(dom) %d\n", dom, strlen(dom));
    printf("FINAL NDOM %s strlen(ndom) %d\n", ndom, strlen(ndom));
}
*/

/*void adjust_domain(access a, access b, statement *sarr, char **dom, int dcount, char *ndom)
{
    int i, j, k, l, m, n, idx, m1, m2, ineq[MAX], exp1[MAX], exp2[MAX];
    char str[MAX], str1[MAX], *token, temp_str[MAX], temp_dom[MAX], *pch, pch_str[MAX][MAX], **lhs, **rhs, oddVar[MAX], ub[MAX], range[MAX][MAX];
    
//access a is a write access with WAW edge and access b is a read access
    lhs = (char **)malloc(MAX * sizeof(char *));
    rhs = (char **)malloc(MAX * sizeof(char *));
    for(i = 0; i < dcount; i++)
    {
        strcpy(temp_str, dom[i]);
        strtok(temp_str, " ");
        if(strcmp(temp_str, a.s) == 0)
            break;
    }
    idx = i;
    strcpy(temp_dom, dom[i]);
    extractStr(temp_dom, "{", "->", pch_str[0]);
    extractStr(temp_dom, "->", "}", pch_str[1]);
    printf("temp dom %s lhs %s rhs %s\n", temp_dom, pch_str[0], pch_str[1]); 
    extract_var(pch_str[0], lhs, &m1, exp1);
    printf("m1 %d\n", m1);
    extract_var(pch_str[1], rhs, &m2, exp2);  
    printf("m2 %d\n", m2);
    if(m1 > m2)
    {
        for(i = m2; i < m1; i++)
        {
            ineq[i] = 1;
        }        
       
        for(n = 0; n < m1; n++)
        {
            if(ineq[n] == 1)
            {
                printf("HERE1\n");
                strcpy(oddVar, lhs[n]);
                for(j = 0; j < MAXNEST; j++)
                {
                    if(sarr[a.st_idx - 1].lhier[n] == sarr[b.st_idx - 1].lhier[j])
                        break;
                }
                if(j == MAXNEST)
                {
                    extractStr(dom[idx], "{", "}", temp_str);
                    pch = strtok(temp_str, ":");
                    strcpy(temp_str, pch);
                    extract_upper_bound(oddVar, ub, dom[idx]);
                    j = 0;
                    for(i = 0; i < strlen(temp_str);)
                    {
                        // if(temp_dom[i] == '[' && temp_dom[i + 1] == oVar && temp_dom[i + 2] == ']')
                        printf("HERE2 temp_str %s oddVar %s ub %s strlen(oddVar) %d\n", temp_str, oddVar, ub, strlen(oddVar));
                        if(temp_str[i] == '[')
                        {
                            for(k = 0; k < strlen(oddVar); k++)
                            {
                                printf("HERE4\n");
                                if(temp_str[i + k + 1] != oddVar[k])
                                {
                                    printf("HERE4 break temp_str[i + k] %c oddVar[k] %c\n", temp_str[i + k], oddVar[k]);
                                    break;
                                }
                            }

                            if(k == strlen(oddVar) && temp_str[i + k + 1] == ']')
                            {
                                printf("Entered here\n");
                                ndom[j] = '[';
                                j++;
                                for(l = 0; l < strlen(ub); l++, j++)
                                {
                                    printf("HERE5\n");
                                    ndom[j] = ub[l];
                                }
                                ndom[j] = ']';
                                j++;
                                i = i + strlen(oddVar) + 2;
                            }
                            else
                            {
                                ndom[j] = temp_str[i];
                                j++;
                                i++;
                            }
                        }
                        else
                        {
                            ndom[j] = temp_str[i];
                            j++;
                            i++;
                        }
                    }
                    ndom[j] = '\0'; 
                    pch = strtok(NULL, ":");
                    strcpy(str, pch);
                    printf("AGAIN NDOM %s str %s\n", ndom, str);
                    sprintf(str1, "%s := {%s: ", a.s, ndom);
                    strcpy(ndom, str1);
                    k = 0;
                    pch = strtok(str, "and");
                    while(pch != NULL)
                    {
                        printf("HERE3\n");
                        strcpy(range[k], pch);
                        pch = strtok(NULL, "and");
                        k++;
                        
                    }
                    sprintf(temp_str, " %s <= ", oddVar);

                    if(strstr(range[0], temp_str))
                    {
                        strcpy(range[0], "");
                    }
                    else
                    {
                        strcat(ndom, range[0]);
                    }
                    for(j = 1; j < k; j++)
                    {
                        if(!strstr(range[j -1], temp_str) && j < k - 1)
                        {
                            strcat(ndom, "and");
                        }

                        if(strstr(range[j], temp_str))
                        {
                            strcpy(range[j], "");
                        }
                        else
                        {
                            strcat(ndom, range[j]);
                        }
                    }
                    strcat(ndom, "};");
                    printf("NDOM %s\n", ndom); 
                    strcpy(dom[idx], ndom);
                }
            }
        }
    }  
}*/


/*
void adjustConfEdge(access a1, access a2, char *dom1, char* dom2, conf_edge *carr, int count)
{
    int i, j, k, l, idx, ocount, flag, m1, m2;
    char str[3*MAX], temp_dom[MAX][MAX], ndom[MAX], ub[MAX], *token, temp[5*MAX], str1[MAX], oddVar[MAX][MAX], **lhs, **rhs;
    lhs = (char **)malloc(MAX * sizeof(char *));
    rhs = (char **)malloc(MAX * sizeof(char *));

    printf("Begin adjustConfEdge\n");
    flag = 0;
    for(i = 0; i < count; i++)
    {
        if(strcmp(carr[i].a1.s, a1.s) == 0 && strcmp(carr[i].a2.s, a2.s) == 0)
        {
            break;
        }
        else if(strcmp(carr[i].a1.s, a2.s) == 0 && strcmp(carr[i].a2.s, a1.s) == 0)
        {
            flag = 1;
            break;
        }
        else
        {
        }
    }

    if(flag == 0)
    {
        ocount = 0;
        extract_lhs_rhs_var(dom1, lhs, &m1, rhs, &m2);
        if(m1 > m2)
        {
            // needs adjustment
            for(i = 0; i < m1; i++)
            {
                for(j = 0; j < m2; j++)
                {
                    if(strcmp(lhs[i], rhs[j]) == 0)
                    {
                        break;
                    }
                }
                if(j == m2)
                {
                    strcpy(oddVar[ocount], lhs[i]);
                    ocount++; 
                }
            }
            for(i = 0; i < dcount; i++)
            {
                strcpy(temp_dom[i], dom[i]);
            }
            for(i = 0; i < dcount; i++)
            {
                strcpy(str, temp_dom[i]);
                token = strtok(str, " ");
                if(strcmp(a1.s, token) == 0)
                {
                    // k is the domain for access a
                    k = i;
                    break;
                }
            }    
            idx = k;
            for(i = 0; i < dcount; i++)
            {
                printf("dom %s\n", dom[i]);
            }
            for(i = 0; i < dcount; i++)
            {
                printf("temp dom %s\n", temp_dom[i]);
            }
            

            // modify domain for a, temp_dom[k] is the the domain for a
            for(i = 0; i < ocount; i++)
            {
                extract_upper_bound(oddVar[i], ub, temp_dom[idx]);                     printf("UPPER BOUND %s\n", ub);
                adjust_domain(oddVar[i], ub, temp_dom[idx], ndom);
                printf("NEW DOMAIN %s\n", ndom);
                strcpy(temp_dom[idx], ndom);
            }

        }
    }*/
   /* printf("access %s\n", a.s);
    printf("temp_dom %s\n", temp_dom[idx]);
    for(i = 0; i < acount; i++)
    {
        printf("access %s, ", aarr[i].s);
    }
    printf("\n");
    for(i = 0; i < count; i++)
    {
        if(strcmp(carr[i].a1.s, a.s) == 0 || strcmp(carr[i].a2.s, a.s) == 0)
        {
            if(sarr[carr[i].a1.st_idx - 1].lis != sarr[carr[i].a2.st_idx - 1].lis)
            {
                printf("Reached here 1 access %s access %s\n", carr[i].a1.s, carr[i].a2.s);
                a1 = carr[i].a1; 
                a2 = carr[i].a2;
                // isccComposition(aarr, acount, carr[i].a1, carr[i].a2, temp, temp_dom);
                for(k=0; k<acount; k++)
		if(strcmp(a2.s, aarr[k].s) == 0)
			break;
                printf("compute k1 %d\n", k);
	        strcpy(temp, temp_dom[k]);

	        for(k=0; k<acount; k++)
		if(strcmp(a1.s, aarr[k].s) == 0)
			break;
                printf("compute k2 %d\n", k);
	        strcat(temp, temp_dom[k]);

	        strcat(temp, a2.s);
	        strcat(temp, "I := ");
	        strcat(temp, a2.s);
	        strcat(temp, "^-1;M := ");
	        strcat(temp, a2.s);
	        strcat(temp, "I( ");
	        strcat(temp, a1.s);
	        strcat(temp, " );M;");
                printf("Reached here 2 %s\n", temp);
                fileHandling(temp);
                //printf("Reached here 3\n");
                strcpy(carr[i].M, temp);
                //printf("Reached here 4\n");
                //carr[idx].flag = 1;
                // printf("Reached here 5\n");
            }
        }
    }*/
//    printf("End adjustConfEdge\n");
//}

void extract_lhs_rhs_var(char *dom, char **lhs, int *m1, char **rhs, int *m2, int *exp1, int *exp2)
{
    int exp[MAX];
    char temp_dom[MAX], pch_str[MAX][MAX], *token;
    strcpy(temp_dom, dom);
    extractStr(temp_dom, "{", "->", pch_str[0]);
    extractStr(temp_dom, "->", "}", pch_str[1]);
    extract_var(pch_str[0], lhs, m1, exp1, 0);
    extract_var(pch_str[1], rhs, m2, exp2, 0);
}

void edit_mapping_for_same_loop_edge(char **lhs, char **rhs, int k, int match_level, char *mapping)
{
    int i;
    char str[3*MAX], str1[MAX];
    for(i = 0; i < strlen(mapping); i++)
    {
        if(mapping[i] == '}')
            mapping[i] = ' ';
    }

    strcpy(str, "");
    for(i = k; i < match_level; i++)
    {
        sprintf(str1, "and %s = %s ", lhs[i], rhs[i]);
        strcat(str, str1);
    }
    strcat(mapping, str);
    strcat(mapping, "}");
}

//This function assigns direction to Conflict Edges - ConstructPreliminaryCAG
int construct_cagp(variable *varr, access *aarr, int acount, conf_edge *carr, statement *sarr, char **dom, int dcount)
{
	int i, j, k, l, m1, m2, m, q1, q2, m3, m4, both_dirn, idx, nsa_count, match_level;
	char a, b;
	char it[2];
	char no[MIN];
	char str[MIN], temp_str[MAX];
	char str1[MAX], name[MAX], *token, temp_dom[3*MAX], *pch, pch_str[MIN][3*MAX], **lhs1, **rhs1, **lhs2, **rhs2, *dom1, *dom2;
	char str2[MAX];
	char temp[5*MAX], mapping[3*MAX];
	expTreeNode *p, *q;
	int ct1, ct2, smaller, flag, ind = 0, count = 0, exp1[MAX], exp2[MAX];
        access *S;

	char **iv1 = (char **)malloc(3 * sizeof(char *));
	char **iv2 = (char **)malloc(3 * sizeof(char *));
	lhs1 = (char **)malloc(MAX * sizeof(char *));
	rhs1 = (char **)malloc(MAX * sizeof(char *));
	lhs2 = (char **)malloc(MAX * sizeof(char *));
	rhs2 = (char **)malloc(MAX * sizeof(char *));
	S = (access*)malloc(acount * sizeof(access));

	for(i=0; i<acount-1; i++)
	{
		if(sarr[aarr[i].st_idx - 1].t != 2 && sarr[aarr[i].st_idx - 1].t != 1)
		{
			for(j=i+1; j<acount; j++)
			{
				if(sarr[aarr[j].st_idx - 1].t != 2 && sarr[aarr[j].st_idx - 1].t != 1)
				{
					isccInterSub(temp, aarr[i].R, aarr[j].R, "*");
					fileHandling(temp);
					// if((aarr[i].t == 1 || aarr[j].t == 1) && (aarr[i].st_idx != aarr[j].st_idx) && (strcmp(aarr[i].r -> n, aarr[j].r -> n) == 0) && strcmp(temp, "{  }") != 0)
					if((aarr[i].t == 1 || aarr[j].t == 1) && (strcmp(aarr[i].r -> n, aarr[j].r -> n) == 0) && strcmp(temp, "{  }") != 0)
					{//printf("%s %s %d %d\n", aarr[i].s, aarr[j].s, sarr[aarr[i].s[1] - '0' - 1].lis, sarr[aarr[j].s[1] - '0' - 1].lis);
						if(sarr[aarr[i].st_idx - 1].lis == sarr[aarr[j].st_idx - 1].lis)
						{
							flag = 0;
							for(k=0; k<dcount; k++)
                                                        {
                                                            l = 0; 
                                                            while(dom[k][l] != ' ')
                                                            {
                                                                name[l] = dom[k][l];
                                                                l++;
                                                            }
                                                            name[l] = '\0';    
							    // if(aarr[i].s[1] == dom[k][1] && aarr[i].s[2] == dom[k][2])
							    if(strcmp(aarr[i].s, name) == 0)
								break;
                                                        }

							ct1 = populateIV(iv1, dom[k]);

							for(k=0; k<dcount; k++)
                                                        {
                                                            l = 0; 
                                                            while(dom[k][l] != ' ')
                                                            {
                                                                name[l] = dom[k][l];
                                                                l++;
                                                            }
                                                            name[l] = '\0';    
   
							    //if(strcmp(aarr[j].s[1] == dom[k][1] && aarr[j].s[2] == dom[k][2])
							    if(strcmp(aarr[j].s, name) == 0)
									break;
                                                        }
							ct2 = populateIV(iv2, dom[k]);
//printf("%d %d\n", ct1, ct2);
							if(ct1 != ct2)
								flag = 1;
							else
							{
								for(k=0; k<ct1; k++)
								{
									if(strcmp(iv1[k], iv2[k]) != 0)
									{
										flag = 1;
										break;
									}
								}
							}
/* k is the loop where the index vectors differ for the first time. o[k] indicates whether that loop is parallel or sequential. If it is parallel, then ind will non-zero and the direction of the edge cannot be ascertained, else it can be ascertained */
							if(flag == 1)
								ind = sarr[aarr[i].st_idx - 1].o[k];
//printf("ind - %d\n", ind);
//printf("k - %d flag - %d\n", k, flag);
							if(flag == 1)
							{
								if(ct1 == ct2)
								{
									p = aarr[i].r -> P[k];
									q = aarr[j].r -> P[k];

									a = p -> n[0];
									b = q -> n[0];
//printf("%c %c\n", a, b);
									if(a >= '0' && a <= '9' || b >= '0' && b <= '9')
									{
										if(a >= '0' && a <= '9')
										{
											strcpy(no, p -> n);
											strcpy(it, q -> n);
										}
										else if(b >= '0' && b <= '9')
										{
											strcpy(no, q -> n);
											strcpy(it, p -> n);
										}
										else
											continue;
/* Creating edge for one direction */
										createEdge(aarr, acount, carr, aarr[i], aarr[j], dom, temp, count);
/* Direction is ascertained after creating the edge. If the direction cannot be ascertained, then it can be ascertained after wait-signal analysis */
										fixDirection(carr, ind, count);
										strcpy(str, it);
										strcat(str, ">");
										strcat(str, no);

										strcpy(mapping, carr[count].M);
										modify(carr[count].M, mapping, str);
										isccDomain(temp, carr[count].M);
										fileHandling(temp);
										if(strcmp(temp, "{  }") == 0)
											carr[count].flag = 0;

										count++;

/* Creating edge for the other direction */
										createEdge(aarr, acount, carr, aarr[j], aarr[i], dom, temp, count);
										fixDirection(carr, ind, count);
										strcpy(str, it);
										strcat(str, "'<");
										strcat(str, no);

										strcpy(mapping, carr[count].M);
										modify(carr[count].M, mapping, str);
										isccDomain(temp, carr[count].M);
										fileHandling(temp);
										if(strcmp(temp, "{  }") == 0)
											carr[count].flag = 0;

										count++;
									}
									else
									{
										if(a == '-')
										{//printf("%s %s\n", p -> P[1] -> n, q -> P[1] -> n);
											if(b == '-' && (atoi(p -> P[1] -> n) < atoi(q -> P[1] -> n)))
												smaller = j;
											else
												smaller = i;
										}
										else if(a == '+')
										{
											if(b == '+' && (atoi(p -> P[1] -> n) < atoi(q -> P[1] -> n)))
												smaller = i;
											else
												smaller = j;
										}
										else
										{
											if(b == '-')
												smaller = j;
											else if(b == '+')
												smaller = i;
										}
//printf("%d\n", smaller);
                                                                                /* Comparing the index vectors to fix the direction */
										if(smaller == i)
										{
											createEdge(aarr, acount, carr, aarr[i], aarr[j], dom, temp, count);
											fixDirection(carr, ind, count);
											count++;
										}
										else
										{
											createEdge(aarr, acount, carr, aarr[j], aarr[i], dom, temp, count);
											fixDirection(carr, ind, count);
											count++;
										}
									}
								}
							}
							else
							{
								createEdge(aarr, acount, carr, aarr[j], aarr[i], dom, temp, count);
								fixDirection(carr, ind, count);
								count++;
							}
						}
						else
						{
							createEdge(aarr, acount, carr, aarr[j], aarr[i], dom, temp, count);
							fixDirection(carr, ind, count);
							count++;
						}
					}
				}
			}
		}
        }

        nsa_count = 0;
        for(i = 0; i < acount; i++)
        {
            for(l = 0; l < dcount; l++)
            {
                strcpy(temp_str, dom[l]);
                token = strtok(temp_str, " ");    
                if(strcmp(aarr[i].s, token) == 0)
                {
                   break;
                }    
            }
            if(aarr[i].t == 1 && sarr[aarr[i].st_idx - 1].t != 2) // Write access, not a signal access
            {
                extract_lhs_rhs_var(dom[l], lhs1, &m1, rhs1, &m2, exp1, exp2);
                if(m1 > m2)
                {
                    // many-to-one mapping
                    addNSAEdge(aarr[i], aarr[i], dom[l], dom[l], carr, &count, 0, sarr, 1);
                    S[nsa_count] = aarr[i];
                    aarr[i].WAW_edge = 1;
                    nsa_count++;
                }
                else
                {
                    aarr[i].WAW_edge = 0;
                }
            }
            else if(aarr[i].t == 0 && sarr[aarr[i].st_idx - 1].t != 1) // read access, not a wait access 
            {
                extract_lhs_rhs_var(dom[l], lhs1, &m1, rhs1, &m2, exp1, exp2);
                if(m1 > m2)
                {
                    // many-to-one mapping
                    S[nsa_count] = aarr[i];
                    nsa_count++;
                }
                aarr[i].WAW_edge = 0;
            }
            else
            {
                aarr[i].WAW_edge = 0;
            }
        }


        for(i = 0; i < nsa_count-1; i++)
	{
		for(j = i + 1; j < nsa_count; j++)
		{
			isccInterSub(temp, S[i].R, S[j].R, "*");
			fileHandling(temp);
			if(((S[i].t == 0 && S[j].t == 1) || (S[i].t == 1 && S[j].t == 0)) 
                          && (strcmp(S[i].r -> n, S[j].r -> n) == 0) && strcmp(temp, "{  }") != 0)
                        {
                            for(l = 0; l < dcount; l++)
                            {
                                strcpy(temp_str, dom[l]);
                                token = strtok(temp_str, " ");    
                                if(strcmp(S[i].s, token) == 0)
                                {
                                    break;
                                }    
                            }
                            extract_lhs_rhs_var(dom[l], lhs1, &m1, rhs1, &m2, exp1, exp2);
                            dom1 = dom[l];

                            for(l = 0; l < dcount; l++)
                            {
                                strcpy(temp_str, dom[l]);
                                token = strtok(temp_str, " ");    
                                if(strcmp(S[j].s, token) == 0)
                                {
                                    break;
                                }    
                            }
                            extract_lhs_rhs_var(dom[l], lhs2, &m3, rhs2, &m4, exp1, exp2);
                            dom2 = dom[l];
                            if(S[i].st_idx != S[j].st_idx)
                            {
                                flag = 0;
                                for(k = 0; k < count; k++)
                                {
                                    if(strcmp(carr[k].a1.s, S[i].s) == 0 && strcmp(carr[k].a2.s, S[j].s) == 0)
                                        break;
                                    else if(strcmp(carr[k].a1.s, S[j].s) == 0 && strcmp(carr[k].a2.s, S[i].s) == 0)
                                    {
                                        flag = 1;
                                        break;
                                    }
                                    else
                                    {
                                    }
                                }
                                idx = k;
                                for(k = 0; k < MAXNEST; k++)
                                {
                                    if(sarr[S[i].st_idx - 1].lhier[k] != sarr[S[j].st_idx - 1].lhier[k])
                                    {
                                        break;
                                    }
                                }
                                match_level = k;
                                if(match_level == 0)
                                {
                                    // the edge is already there
                                }
                                else
                                {
                                    replaceCommaWithBrackets(carr[idx].M, mapping);
                                    strcpy(carr[idx].M, mapping);
                                    extract_lhs_rhs_var(mapping, lhs1, &m1, rhs1, &m2, exp1, exp2);
                                    for(k = 0; k < match_level; k++)
                                    {
                                        if(strcmp(lhs1[k], rhs1[k])) break;
                                    }

                                    if(k == match_level)
                                    {
                                        // the edge is already there
                                    }
                                    else
                                    {
                                        if(k == varr[S[i].var_idx].r)
                                        {
                                            if(carr[idx].a1.st_idx > carr[idx].a2.st_idx)
                                            {
                                                edit_mapping_for_same_loop_edge(lhs1, rhs1, k, match_level, carr[idx].M);
                                            }
                                        }
                                        else
                                        {
                                            if(idx != count)
                                            {
                                                 // the edge with one direction is there
                                                 if(flag == 1)
                                                     addNSAEdge(S[i], S[j], dom1, dom2, carr, &count, 0, sarr, 0);
                                                 else
                                                     addNSAEdge(S[j], S[i], dom2, dom1, carr, &count, 0, sarr, 0);
                                            }
                                            else
                                            {
                                                addNSAEdge(S[i], S[j], dom1, dom2, carr, &count, 1, sarr, 0);
                                            }
                                        }
                                    }
                                }
                                //extractStr(carr[k].M, "{", "}", str);
                             /*   replaceCommaWithBrackets(carr[k].M, mapping);
                                printf("MAPPING %s flag %d\n", mapping, flag);
                                extract_lhs_rhs_var(mapping, lhs1, &m1, rhs1, &m2);
                                idx = k;
                                if(m1 > m2)
                                {
                                    for(k = 0; k < m2; k++)
                                    {
                                        if(strcmp(lhs1[k], rhs1[k]))
                                        {
                                            break;
                                        }
                                    }
                                    if(k == m2)
                                    {
                                        // resorts to single direction
                                    }
                                    else
                                    {
                                        // edge with other direction has to be added
                                        printf("Edge with other direction has to be added\n");
                                        if(flag == 1)
                                        {
                                            edit_mapping(lhs1, m1, rhs1, m2, mapping, carr[k].M);
                                            addNSAEdge(aarr[i], aarr[j], dom1, dom2, carr, &count, 0);
                                        }
                                        else
                                        {
                                            edit_mapping(lhs1, m1, rhs1, m2, mapping, carr[k].M);
                                            addNSAEdge(aarr[j], aarr[i], dom2, dom1, carr, &count, 0);
                                        }
                                    }
                                }
                                else if(m2 > m1)
                                {
                                    for(k = 0; k < m1; k++)
                                    {
                                        if(strcmp(lhs1[k], rhs1[k]))
                                        {
                                            break;
                                        }
                                    }
                                    if(k == m1)
                                    {
                                        // resorts to single direction
                                    }
                                    else
                                    {
                                        // edge with other direction has to be added
                                        printf("Edge with other direction has to be added\n");
                                        if(flag == 1)
                                        {
                                            edit_mapping(lhs1, m1, rhs1, m2, mapping, carr[k].M);
                                            addNSAEdge(aarr[i], aarr[j], dom1, dom2, carr, &count, 0);
                                        }
                                        else
                                        {
                                            edit_mapping(lhs1, m1, rhs1, m2, mapping, carr[k].M);
                                            addNSAEdge(aarr[j], aarr[i], dom2, dom1, carr, &count, 0);
                                        }
                                    }
                                }
                                else
                                {
                                    // edge with other direction has to be added
                                    printf("Edge with other direction has to be added\n");
                                    if(flag == 1)
                                    {
                                        edit_mapping(lhs1, m1, rhs1, m2, mapping, carr[k].M);
                                        addNSAEdge(aarr[i], aarr[j], dom1, dom2, carr, &count, 0);
                                    }
                                    else
                                    {
                                        edit_mapping(lhs1, m1, rhs1, m2, mapping, carr[k].M);
                                        addNSAEdge(aarr[j], aarr[i], dom2, dom1, carr, &count, 0);
                                    }
                                }*/
                             }
                             else
                             {
                                 // edge with both the direction has to be added
                                 addNSAEdge(S[i], S[j], dom1, dom2, carr, &count, 1, sarr, 1);
                             }
                    }
              }
         }
       
  /*      flag_WAW = 0;
        for(i = 0; i < acount; i++)
        {
            if(aarr[i].t == 1) // Write access
            {
               for(l = 0; l < dcount; l++)
               {
                   strcpy(temp_str, dom[l]);
                   token = strtok(temp_str, " ");    
                   if(strcmp(aarr[i].s, token) == 0)
                   {
                       break;
                   }    
               }
               extract_lhs_rhs_var(dom[l], lhs, &m1, rhs, &m2);
                printf("m1 %d m2 %d\n", m1, m2);
                if(m1 > m2)
                {
                    printf("Candidate for WAW edge\n");
                    // addWAWedge(aarr[i], dom[l], lhs, m1, rhs, m2, carr, &count, oddVar, &ocount);
                    addNSAEdge(aarr[i], aarr[i], dom[l], dom[l], carr, count);
                    for(q1 = 0; q1 < acount; q1++)
                    {
                        if(aarr[q1].t == 0 && (strcmp(aarr[i].r -> n, aarr[q1].r -> n) == 0)) // read access
                        {
                            printf("Read access aarr[q1].s %s lis %d lis %d\n", aarr[q1].s, sarr[aarr[q1].st_idx - 1].lis, sarr[aarr[i].st_idx - 1].lis);
                            for(q2 = 0; q2 < dcount; q2++)
                            {
                                strcpy(temp_str, dom[q2]);
                                token = strtok(temp_str, " ");
                                if(strcmp(aarr[q1].s, token) == 0)
                                {
                                    break;
                                }
                            }
                            if(sarr[aarr[q1].st_idx - 1].lis == sarr[aarr[i].st_idx - 1].lis)        
                            {
                                
                                 addNSAEdge(aarr[i], aarr[q1], dom[l], dom[q2], carr, count);
                            }                      
                            else
                            {
                                adjustConfEdge(aarr[i], aarr[q1], dom[l], dom[q2], carr, count);
                            }
                        }
                    }*/
                    
                    /*for(i = 0; i < dcount; i++)
                    {
                        strcpy(mod_dom[i], dom[i]);
                    }*/
                //    aarr[i].WAW_edge = 1;
                    //flag_WAW = 1;
                //}
                //else
                //{
                //    aarr[i].WAW_edge = 0;
       //         }
       //     }
       // }

	return count;
}
