#include "head.h"

void print_array_to_file(FILE *fp, variable *varr, int vcount)
{
    int i;
    int op_count, other_count;
    int op_index[100], other_index[100];

    op_count = other_count = 0;
    fprintf(fp, "---\n");
    fprintf(fp, "arrays:\n");
    for(i = 0; i < vcount; i++)
    {
        if(varr[i].io != 2)
        {
            // input or temporary array
            fprintf(fp, "  - &%s\n", varr[i].combined_yaml_name);
            fprintf(fp, "    analysis_performed:\n");
            if(varr[i].io != 1)
            {
                // temporary array
                fprintf(fp, "      -\n");
                fprintf(fp, "        type: flow\n");
                fprintf(fp, "      -\n");
                fprintf(fp, "        type: output\n");
            }
            fprintf(fp, "    dims: [100]\n");
            fprintf(fp, "    element_type: &%s int\n", varr[i].yaml_type);
            fprintf(fp, "    id: -1\n");
            fprintf(fp, "    name: &%s %s\n", varr[i].yaml_name, varr[i].n);
            fprintf(fp, "    type: temp\n");
            fprintf(fp, "    uniquely_defined: 0\n");

            other_index[other_count] = i;
            other_count++;
        }
        else
        {
            // output array
            op_index[op_count] = i;
            op_count++;
        }
    }
 
    for(i = 0; i < op_count; i++)
    {
            // output array
            fprintf(fp, "  - &%s\n", varr[op_index[i]].yaml_name);
            fprintf(fp, "    analysis_performed:\n");
            fprintf(fp, "      -\n");
            fprintf(fp, "        type: flow\n");
            fprintf(fp, "      -\n");
            fprintf(fp, "        type: output\n");
            fprintf(fp, "    dims: [100]\n");
            fprintf(fp, "    element_type: int\n");
            fprintf(fp, "    id: -1\n");
            fprintf(fp, "    name: %s\n", varr[op_index[i]].n);
            fprintf(fp, "    type: output\n");
            fprintf(fp, "    uniquely_defined: 0\n");
    }

    for(i = 0; i < other_count; i++)
    {
            // input or temporary array
            fprintf(fp, "  - &%s\n", varr[other_index[i]].uninit_yaml_name);
            fprintf(fp, "    dims: [100]\n");
            fprintf(fp, "    element_type: *%s\n", varr[other_index[i]].yaml_type);
            fprintf(fp, "    id: -1\n");
            fprintf(fp, "    name: *%s\n", varr[other_index[i]].yaml_name);
            fprintf(fp, "    type: input\n");
            fprintf(fp, "    uniquely_defined: 0\n");
    }
}

void extractStNameFromAccName(char *an, char *sn)
{
    int i;
    for(i = 0; i < (strlen(an) - 1); i++)
    {
        sn[i] = an[i];
    }
    sn[i] = '\0';
}

void modify_conf_edge_mapping(char *input_map, access a1, access a2, char *output_map)
{
     int i, j, k, idx1, idx2, k1, k2, k3, k4;
     char an1[3*MAX], an2[3*MAX];

     extractStNameFromAccName(a1.s, an1);
     extractStNameFromAccName(a2.s, an2);
     printf("Map %s comp %d\n", input_map, strcmp(input_map, ""));     
     for(i = 0; ; i++)
     {
         if(input_map[i] == '[')
         {
             idx1 = i;
             break;
         }
     }

     for(i = 0; ; i++)
     {
         if(input_map[i] == '-' && input_map[i + 1] == '>')
         {
             idx2 = i + 3;
             break;
         }
     }
     printf("idx1 %d idx2 %d\n", idx1, idx2);

     for(i = 0; i < idx1; i++)
     {
         output_map[i] = input_map[i];
     }
     k1 = i;
     for(j = 0; j < strlen(an1); j++)
     {
         output_map[k1 + j] = an1[j];
     }
     k2 = k1 + j;
     for(i = idx1, k = 0; i < idx2; i++, k++)
     {
         output_map[k2 + k] = input_map[i];
     }
     k3 = k2 + k;
     for(j = 0; j < strlen(an2); j++)
     {
         output_map[k3 + j] = an2[j];
     }
     k4 = k3 + j;
     for(i = idx2, k = 0; i < strlen(input_map); i++, k++)
     {
         output_map[k4 + k] = input_map[i];
     }
     output_map[k4 + k] = '\0';
}

void print_accesses_for_statement(FILE *fp, char *sn, int st_idx, variable *varr, int vcount, statement *sarr, int scount, access *aarr, int acount, int count, int read_acc_idx[], int rcount, int write_acc_idx[], int wcount)
{
    int i, j, k;
    char str[3*MAX];
    
    for(i = 0; i < rcount; i++)
    {
        k = read_acc_idx[i];
        strcpy(str, "");
        fprintf(fp, "          - &%s\n", aarr[k].yaml_name);
        fprintf(fp, "            array: *%s\n", varr[aarr[k].var_idx].combined_yaml_name);
        printf("st id %d var id %d combined yaml_name %s\n", st_idx, aarr[k].var_idx, varr[aarr[k].var_idx].combined_yaml_name);
        sprintf(str, "\"{ %s", sn);
        if(sarr[st_idx].d == 0)
        {
            strcat(str, " -> ");
            strcat(str, aarr[k].r->n);
            strcat(str, " }\"");
        }
        else if(sarr[st_idx].d == 1)
        {
            strcat(str, "[i] -> ");
            strcat(str, aarr[k].r->n);
            strcat(str, "[");
            constructExpBack(aarr[k].r->P[0], str);
            strcat(str, "] }\"");
        }
        else if(sarr[st_idx].d == 2)
        {
            strcat(str, "[i] -> ");
            strcat(str, aarr[k].r->n);
            strcat(str, "[");
            constructExpBack(aarr[k].r->P[0], str);
            strcat(str, ", ");
            constructExpBack(aarr[k].r->P[1], str);
            strcat(str, "] }\"");
        }
        else
        {
            // loop depth upto 2 is supported
        }
        fprintf(fp, "            map: %s\n", str);
        fprintf(fp, "            nr: %d\n", count);
        fprintf(fp, "            type: read\n");
    }

    for(i = 0; i < wcount; i++)
    {
        k = write_acc_idx[i];
        strcpy(str, "");
        fprintf(fp, "          - &%s\n", aarr[k].yaml_name);
        if(varr[aarr[k].var_idx].io == 0)
        {
            // temporary array
            fprintf(fp, "            array: *%s\n", varr[aarr[k].var_idx].combined_yaml_name);
        }
        else
        {
            // output array
            fprintf(fp, "            array: *%s\n", varr[aarr[k].var_idx].yaml_name);
        }
        sprintf(str, "\"{ %s", sn);
        if(sarr[st_idx].d == 0)
        {
            strcat(str, " -> ");
            strcat(str, aarr[k].r->n);
            strcat(str, " }\"");
        }
        else if(sarr[st_idx].d == 1)
        {
            strcat(str, "[i] -> ");
            strcat(str, aarr[k].r->n);
            strcat(str, "[");
            constructExpBack(aarr[k].r->P[0], str);
            strcat(str, "] }\"");
        }
        else if(sarr[st_idx].d == 2)
        {
            strcat(str, "[i] -> ");
            strcat(str, aarr[k].r->n);
            strcat(str, "[");
            constructExpBack(aarr[k].r->P[0], str);
            strcat(str, ", ");
            constructExpBack(aarr[k].r->P[1], str);
            strcat(str, "] }\"");
        }
        else
        {
            // loop depth upto 2 is supported
        }
        fprintf(fp, "            map: %s\n", str);
        fprintf(fp, "            nr: %d\n", count);
        fprintf(fp, "            type: write\n");
    }

}

void print_statement(FILE *fp, char *sn, int st_idx, variable *varr, int vcount, statement *sarr, int scount, access *aarr, int acount, conf_edge *carr, int ecount, vertex *dvarr, int *dvcount, dep_edge *dearr, int decount)
{
    int k;
    int count, rcount, wcount;
    int read_acc_idx[5], write_acc_idx[5];
    char str[3*MAX];

    if(sarr[st_idx].yaml_flag != 1)
    {
        fprintf(fp, "      name: %s\n", sn);
        fprintf(fp, "      nr: 0\n");
        if(sarr[st_idx].d == 0)
        {
            fprintf(fp, "      prefix: [-1, -1, -1]\n");
        }
        else if(sarr[st_idx].d == 1)
        {
            fprintf(fp, "      prefix: [%d, -1, %d]\n", sarr[st_idx].d, sn[1] - '0' - 1);
        }
        else if(sarr[st_idx].d == 2)
        {
            fprintf(fp, "      prefix: [%d, 1, %d]\n", sarr[st_idx].d, sn[1] - ' 0' - 1);
        }
        else
        {
            // loop depth upto 2 is supported
        }
        fprintf(fp, "      source: \"{ %s[i] : %s }\"\n", sn, sarr[st_idx].D);
        fprintf(fp, "      statement: \n");
        fprintf(fp, "        accesses: \n");
        count = rcount = wcount = 0;
        for(k = 0; k < acount; k++)
        {
            if(sn[1] ==  aarr[k].s[1])
            {
                if(aarr[k].t == 0)
                {
                    read_acc_idx[rcount] = k;
                    rcount++;
                }
                else
                {
                    write_acc_idx[rcount] = k;
                    wcount++;
                }
                count++;
            }
        }
        print_accesses_for_statement(fp, sn, st_idx, varr, vcount, sarr, scount, aarr, acount, count, read_acc_idx, rcount, write_acc_idx, wcount);
        fprintf(fp, "        line: 0\n");
        fprintf(fp, "        operation: -1\n");
        fprintf(fp, "        top_function:\n");
        fprintf(fp, "          arguments:\n");
        printf("rcount %d\n", rcount);
        for(k = 0; k < rcount; k++)
        {
            fprintf(fp, "            -\n");
            fprintf(fp, "             access: *%s\n", aarr[read_acc_idx[k]].yaml_name);
            fprintf(fp, "             type: access\n");
        } 
        fprintf(fp, "          name:\n");
        fprintf(fp, "        top_outputs:\n");
        fprintf(fp, "          - *%s\n", aarr[write_acc_idx[0]].yaml_name);
        sarr[st_idx].yaml_flag = 1;
    }
}

void print_conflict_edge(FILE *fp, int index, variable *varr, int vcount, statement *sarr, int scount, access *aarr, int acount, conf_edge *carr, int ecount, vertex *dvarr, int *dvcount, dep_edge *dearr, int decount)
{
    int j, idx;
    char sn[3*MAX], str_map[3*MAX], map[3*MAX];

    fprintf(fp, "  -\n");
    j = carr[index].a2.var_idx;
    fprintf(fp, "    array: *%s\n", varr[j].combined_yaml_name);
    fprintf(fp, "    from: &%s\n", sarr[carr[index].a2.s[1] - '0' - 1].yaml_name);
    extractStNameFromAccName(carr[index].a2.s, sn);
    print_statement(fp, sn, carr[index].a2.s[1] - '0' - 1, varr, vcount, sarr, scount, aarr, acount, carr, ecount, dvarr, dvcount, dearr, decount);
    for(idx = 0; idx < acount; idx++)
    {
        if(!strcmp(aarr[idx].s, carr[index].a2.s))
            fprintf(fp, "    from_access: *%s\n", aarr[idx].yaml_name);
    }
    fprintf(fp, "    multiplicity: -1\n");
    if(carr[index].t == 0)
    {
        modify_conf_edge_mapping(carr[index].included_M, carr[index].a1, carr[index].a2, map);
    }
    else
    {
        modify_conf_edge_mapping(carr[index].M, carr[index].a1, carr[index].a2, map);
    }
    // printf("Map in gen %s\n", carr[i].M);
    strcpy(str_map, "M := "); 
    strcat(str_map, map);
    strcat(str_map, ";");
    strcat(str_map, "M1 := M^-1; M1;");
    fileHandling(str_map);
    fprintf(fp, "    relation: \"%s\"\n", str_map);
    fprintf(fp, "    reordering: -1\n");
    fprintf(fp, "    to: &%s\n", sarr[carr[index].a1.s[1] - '0' - 1].yaml_name);
    extractStNameFromAccName(carr[index].a1.s, sn);
    print_statement(fp, sn, carr[index].a1.s[1] - '0' - 1, varr, vcount, sarr, scount, aarr, acount, carr, ecount, dvarr, dvcount, dearr, decount);
    for(idx = 0; idx < acount; idx++)
    {
        if(!strcmp(aarr[idx].s, carr[index].a1.s))
            fprintf(fp, "    to_access: *%s\n", aarr[idx].yaml_name);
    }
    if(carr[index].t == 0)
    {
        fprintf(fp, "    type: flow\n");   
    }
    else
    {
        fprintf(fp, "    type: output\n");   
    }
}

void print_dependence(FILE *fp, variable *varr, int vcount, statement *sarr, int scount, access *aarr, int acount, conf_edge *carr, int ecount, vertex *dvarr, int *dvcount, dep_edge *dearr, int decount)
{
    int i, j, k, l, val, idx, temp_idx, assigned_val, count[3*MAX];
    char str[3*MAX], str_map[3*MAX], sn[MAX], map[3*MAX];
    

    val = 4*(vcount - 1) + 2;
    /*for(i = 0; i < scount; i++)
    {
        // assign names to statements
        snprintf(sarr[i].yaml_name, 2*MAX, "%d", (val + i));
    }

    val = val + scount;*/
    for(i = 0; i < acount; i++)
    {
        // assign names to accesses
        // snprintf(aarr[i].yaml_name, 2*MAX, "%d", (val + i));
        printf("access name %s\n", aarr[i].s);
        for(j = 0; j < vcount; j++)
        {
            if(!strcmp(aarr[i].r->n, varr[j].n))
                aarr[i].var_idx = j;
        }
    }
    
    for(i = 0; i < scount; i++)
    {
        count[i] = 0;
        for(j = 0; j < acount; j++)
        {
            if(aarr[j].s[1] - '0' == i + 1)
            {
                count[i]++;
            }
        }
        printf("count[%d] = %d\n", i, count[i]);
    }

    k = 0;
    for(i = 0; i < scount; i++)
    {
        snprintf(sarr[i].yaml_name, 2*MAX, "%d", val);
        temp_idx = k;
        k++;
        val++;
        for(j = 1; j < count[i]; j++)
        {
            snprintf(aarr[k].yaml_name, 2*MAX, "%d", val);
            val++;
            k++;
        }
        snprintf(aarr[temp_idx].yaml_name, 2*MAX, "%d", val);
        val++;
    }
    
    for(i = 0; i < ecount; i++)
    {
        if(carr[i].t == 0)
        {
            // RAW edges
            print_conflict_edge(fp, i, varr, vcount, sarr, scount, aarr, acount, carr, ecount, dvarr, dvcount, dearr, decount);
        }
    }

    for(i = 0; i < ecount; i++)
    {
        if(carr[i].t == 2)
        {
            // WAW edges
            print_conflict_edge(fp, i, varr, vcount, sarr, scount, aarr, acount, carr, ecount, dvarr, dvcount, dearr, decount);
        }
    }
}

/* Replace str1 string with str2 in str to produce new_str */
void replaceAll(char *str, char *new_str, char *str1, char *str2)
{
    int i, j, k, len, idx, occ[MAX];

    k = 0;
    for(i = 0; i < strlen(str) - strlen(str1); i++)
    {
        for(j = 0; j < strlen(str1); j++)
        {
            if(str[i + j] != str1[j])
            {
                break;
            }
        }
        if(j == strlen(str1))
        {
            occ[k] = i;
            k++;
        }
    }
    printf("k = %d\n", k);

    len = 0; idx = 0;
    for(i = 0; i < k; i++)
    {
        for(j = idx; j < occ[i]; j++)
        {
            new_str[len] = str[j];
            len++;
        }

        printf("occ[i] %d\n", occ[i]);
        for(j = 0; j < strlen(str2); j++)
        {
            new_str[len] = str2[j];
            len++;
        }
        idx = occ[i] + strlen(str1);
    }

    for(i = idx; i < strlen(str); i++)
    { 
        new_str[len] = str[i];
        len++;
    }
    new_str[len] = '\0';
}

void print_uninit_read(FILE *fp, variable *varr, int vcount, statement *sarr, int scount, access *aarr, int acount, conf_edge *carr, int ecount, vertex *dvarr, int *dvcount, dep_edge *dearr, int decount)
{
    int  i, j, k;
    int index;
    char str[3*MAX], new_str[3*MAX], temp[3*MAX], sn[MIN], sa_dom[3*MAX], dom[3*MAX];
    statement st;
    
    for(i = 0; i < acount; i++)
    {
        printf("i %d\n access yaml name %s\n", i, aarr[i].yaml_name);
    }

    strcpy(str, "");
    for(i = 0; i < acount; i++)
    {
        if(aarr[i].t == 0) // read access
        {
            if(varr[aarr[i].var_idx].io == 1)
            {
                // input array 
                fprintf(fp, "  -\n");
                fprintf(fp, "    array: *%s\n", varr[aarr[i].var_idx].uninit_yaml_name);
                fprintf(fp, "    multiplicity: -1\n");
                strcpy(str, "{ [] -> ");
                extractStNameFromAccName(aarr[i].s, sn);
                strcat(str, sn);
                strcat(str, "[i] : ");
	        strcat(str, sarr[aarr[i].s[1] - '0' - 1].D);
	        strcat(str, " }");
                fprintf(fp, "    relation: \"%s\"\n", str);
                fprintf(fp, "    reordering: -1\n");
                fprintf(fp, "    to: *%s\n", sarr[aarr[i].s[1] - '0' - 1].yaml_name);
                fprintf(fp, "    to_access: *%s\n", aarr[i].yaml_name);
                fprintf(fp, "    type: uninitialized\n");
            }
            else if(varr[aarr[i].var_idx].io == 0)
            {
                // temporary array  
                k = 0;
                strcpy(str, "");
                while(aarr[i].S[k].s[0] != '\0')
	        {
                    sprintf(temp, "S%d := ", k);
                    strcat(str, temp);
                    strcat(str, aarr[i].S[k].D);
                    strcat(str, ";");
                    k++;
                }
                strcat(str, "S := ");
                for(j = 0; j < k; j++)
                {
                    sprintf(temp, "S%d", j);
                    strcat(str, temp);
                    if(j < k - 1)
                    {
                        strcat(str, "+");
                    }
                    else
                    {
                        strcat(str, ";S;");
                    }
                }
		fileHandling(str);
                replaceAll(str, sa_dom, "i0", "i");

                strcpy(str, "");
                constructExpBack(aarr[i].r->P[0], str);
                index = aarr[i].s[1];
                st = sarr[(index-'0')-1];
                if(st.d == 1)
                {
                    strcpy(temp, "{[i] -> [");
                    strcat(temp, str);
                    strcat(temp, "] :");
                    extractStr(sa_dom, ":", "}", dom);
                    replaceAll(dom, sa_dom, "i", str);
                    strcat(temp, sa_dom);
                    strcat(temp, " } ");
                    strcpy(str, "M := ");
                    strcat(str, temp);
                    strcat(str, "; M1 := M^-1;S := ran M1;S;");
                    printf("Before S<alpha> union %s\n", str);
                    fileHandling(str);
                    printf("After S<alpha> union %s\n", str);
                    
                    strcpy(dom, str);
                    strcpy(str, "S1 := {[i] :");
                    strcat(str, st.D);
                    strcat(str, "}; S2 := ");
                    strcat(str, dom);
                    strcat(str, ";S := S1 - S2; S;");
                    printf("Before negation %s\n", str);
                    fileHandling(str);
                    printf("After negation %s\n", str);
                    if(strcmp(str, "{  }"))
                    {
                        fprintf(fp, "  -\n");
                        fprintf(fp, "    array: *%s\n", varr[aarr[i].var_idx].uninit_yaml_name);
                        fprintf(fp, "    multiplicity: -1\n");
                        extractStNameFromAccName(aarr[i].s, sn);
                        extractStr(str, "[", "]", dom);
                        fprintf(fp, "    relation: \"{ [] -> %s[%s] }\"\n", sn, dom);
                        fprintf(fp, "    reordering: -1\n");
                        fprintf(fp, "    to: *%s\n", st.yaml_name);
                        fprintf(fp, "    to_access: *%s\n", aarr[i].yaml_name);
                        fprintf(fp, "    type: uninitialized\n");
                     
                    }
                 }
            }
            else
            {
            }

        }
    }
}

void generateYamlFile(variable *varr, int vcount, statement *sarr, int scount, access *aarr, int acount, conf_edge *carr, int ecount, vertex *dvarr, int *dvcount, dep_edge *dearr, int decount)
{
    int i, j;
    FILE *fp;

    fp = fopen("source_da.yaml", "w");

    printf("vcount %d\n", vcount);
    for(i = 0, j = 1; i < vcount; i++)
    {
        if(varr[i].io != 2)
        {
            snprintf(varr[i].combined_yaml_name, 10, "%d", j);
            snprintf(varr[i].yaml_type, 10, "%d", j + 1);
            snprintf(varr[i].yaml_name, 10, "%d", j + 2);
            snprintf(varr[i].uninit_yaml_name, 10, "%d", j + 3);
            j = j + 4;
        }
        else
        {
            snprintf(varr[i].yaml_name, 10, "%d", j);
            j++;
        }
    }
    for(i = 0; i < scount; i++)
    {
        sarr[i].yaml_flag = 0;
    }
    print_array_to_file(fp, varr, vcount);
    fprintf(fp, "cacheline: -1\n");
    fprintf(fp, "context: \"{  :  }\" \n");
    fprintf(fp, "dependences:\n");
    print_dependence(fp, varr, vcount, sarr, scount, aarr, acount, carr, ecount, dvarr, dvcount, dearr, decount);
    print_uninit_read(fp, varr, vcount, sarr, scount, aarr, acount, carr, ecount, dvarr, dvcount, dearr, decount);
    fprintf(fp, "dimension: 0\n");
    fprintf(fp, "history:\n");
    fprintf(fp, "  -\n");
    fprintf(fp, "    arguments:\n");
    fprintf(fp, "      - source.c\n");
    fprintf(fp, "    tool: c2pdg\n");
    fprintf(fp, "    version: \"isa-0.12\"\n");
    fprintf(fp, "  -\n");
    fprintf(fp, "    tool: da\n");
    fprintf(fp, "    version: \"isa-0.12\"\n");
    fprintf(fp, "name: source\n");
    fprintf(fp, "nodes:\n");
    for(i = 0; i < scount; i++)
    {
        fprintf(fp, "  - *%s\n", sarr[i].yaml_name);
    }
    fprintf(fp, "placement: original\n");
    fprintf(fp, "root: -1\n");
    fprintf(fp, "statement_dimensions: []\n");
    fclose(fp);
}
