#include "head.h"

//This function stores all the wait and signal accesses in aws
int populateWaitSignal(access *aws, statement *sarr, access *aarr, int acount)
{
	int i, count = 0;

	for(i=0; i<acount; i++)
		if(sarr[aarr[i].st_idx - 1].t == 1 || sarr[aarr[i].st_idx - 1].t == 2)
                {
			aws[count++] = aarr[i];
                }

	return count;
}

/*This function creates wait-signal graph which consists of all the wait and
signal accesses present in the program connected by the conflict edges as well
as the control flow edges*/
void construct_ws(access *aarr, int acount, statement *sarr, conf_edge *carr, int *ecount, access *aws, int count, conf_edge *ews[], conf_edge *fsw[], char **dom)
{
	int i, j, k;
	int idx;

	char it[2];
	char str1[2*MIN];
	char str2[MAX];
	char str[3*MAX];
	char temp[3*MAX];

	for(i=0; i<count; i++)
	{
		if(sarr[aws[i].st_idx - 1].t == 1)								//if the access is wait access
		{
			idx = 1;
			memset(str, '\0', sizeof(str));
			for(j=0; j<count; j++)
			{
				if(sarr[aws[j].st_idx - 1].t == 2 && strcmp(aws[i].r -> n, aws[j].r -> n) == 0)
				{
                                        /* Creating edge if wait and signal statements work on the same lock array */
					ews[i][j].a1 = aws[i];
					ews[i][j].a2 = aws[j];
					ews[i][j].t = 0;

					//isccComposition(aarr, acount, ews[i][j].a1, ews[i][j].a2, temp, dom);
					isccComposition(aarr, acount, ews[i][j].a1, ews[i][j].a2, temp, dom);
					fileHandling(temp);
					strcpy(ews[i][j].M, temp);
					ews[i][j].flag = 1;
					ews[i][j].dir = 1;

					carr[(*ecount)++] = ews[i][j];

					strcat(str, "S");
					sprintf(it, "%d", idx);
					strcat(str, it);
					strcat(str, " := ");
					strcat(str, aws[j].R);
					strcat(str, ";");
					idx++;
				}
			}
                        
                        
			strcat(str, "S := S");
			for(k=1; k<idx-1; k++)
			{
				sprintf(it, "%d", k);
				strcat(str, it);
				strcat(str, " + S");
			}
			sprintf(it, "%d", k);
			strcat(str, it);
			strcat(str, ";S;");
			fileHandling(str);
/* Creating union of all the signal statements to check with the domain of the wait statement */
			isccInterSub(temp, aws[i].R, str, "-");
			fileHandling(temp);
			if(strcmp(temp, "{  }") != 0)
			{
                                endcputime = (double)clock();
                                //printf("Time taken %lf\n", (endcputime - startcputime)/CLOCKS_PER_SEC);
				printf("Deadlock situation exists\n");		//deadlock exists if union of signals is less than wait
				exit(0);
			}
		}
		else if(sarr[aws[i].st_idx - 1].t == 2)							//if the access is signal access
		{
			for(j=0; j<count; j++)
			{
				if(sarr[aws[j].st_idx - 1].t == 1 && aws[j].st_idx < aws[i].st_idx)
				{
                                        /* Creating control flow edge from signal to wait statements */
					fsw[i][j].a1 = aws[i];
					fsw[i][j].a2 = aws[j];
					fsw[i][j].t = 1;

					isccInterSub(temp, fsw[i][j].a1.R, fsw[i][j].a2.R, "*");
					fileHandling(temp);

					parse(str1, temp, 0);
					parse(str2, temp, 1);
					strcpy(temp, "{");
					strcat(temp, str1);
					strcat(temp, "->");
					strcat(temp, str1);
					strcat(temp, ":");
					strcat(temp, str2);
					strcat(temp, "}");
					strcpy(fsw[i][j].M, temp);
					fsw[i][j].flag = 1;
					fsw[i][j].dir = 1;

					carr[(*ecount)++] = fsw[i][j];
				}
			}
		}
	}
}
