#include "head.h"


int main()
{
        int i, j;
        int count = 0;		//number of wait-signal accesses
	int vcount = 0;		//number of variables
        int scount = 0;		//number of statements
	int acount = 0;		//number of read and write accesses
	int ecount = 0;		//number of conflict edges
	int dcount = 0;		//number of loop to statement mappings
	int pcount = 0;		//number of paths
	int ccount = 0;		//number of cycles
	int dvcount = 0;	//number of DG vertices
	int decount = 0;	//number of DG edges
        
        char file_name[MAX], log_file_name[MAX], orig_file_name[MAX];
        char exec_str[5*MAX];

        printf("Enter the file name : ");
        scanf("%s", file_name);
        strcpy(orig_file_name, file_name);

        startcputime = (double)clock();
	char **dom = (char **)malloc(MAX * sizeof(char *));			//array to store loop to statement mappings
        variable *varr = (variable *)malloc(MAX * sizeof(variable));		//array to store all the variables
        statement *sarr = (statement *)malloc(MAX * sizeof(statement));		//array to store all the statements
  	parseInput(file_name, varr, &vcount, sarr, &scount, dom, &dcount);


        access *aarr = (access *)malloc(5*scount * sizeof(access));			//array to store all the read and write accesses
	acount = populateAccessTable(aarr, sarr, scount, dom, varr, vcount);

	conf_edge *carr = (conf_edge *)malloc(acount * acount * sizeof(conf_edge));	//array to store all the conflict edges
	//ecount = construct_cags(aarr, acount, carr, sarr, dom, dcount);
	ecount = construct_cagp(varr, aarr, acount, carr, sarr, dom, dcount);
	printConflictEdgeTable(carr, ecount);

	access *aws = (access *)malloc(acount * sizeof(access));	//array to store all the wait-signal accesses
	count = populateWaitSignal(aws, sarr, aarr, acount);

	conf_edge **ews = (conf_edge **)malloc(count * sizeof(conf_edge *));		//array to store all the conflict edges between wait-signal accesses
	for(i=0; i<count; i++)
		ews[i] = (conf_edge *)malloc(count * sizeof(conf_edge));

	conf_edge **fsw = (conf_edge **)malloc(count * sizeof(conf_edge *));		//array to store all the conflict edges by virtue of control flow
	for(i=0; i<count; i++)
		fsw[i] = (conf_edge *)malloc(count * sizeof(conf_edge));

	path *pws = (path *)malloc(MAX * sizeof(path));//array to store all the possible paths present in wait-signal subgraph
	path *cws = (path *)malloc(MAX * sizeof(path));//array to store all the possible cycles present in wait-signal subgraph
        
        construct_ws(aarr, acount, sarr, carr, &ecount, aws, count, ews, fsw, dom);

	populateReadAccess(varr, vcount, sarr, aarr, acount, carr, ecount, dom, dcount);
	populateWriteAccess(varr, vcount, sarr, aarr, acount, carr, ecount);
	findPaths(aws, count, sarr, ews, fsw, pws, &pcount, cws, &ccount);
	undirected(aarr, acount, sarr, carr, &ecount, pws, pcount, cws, ccount, ews, count, dom);
	checkDeterminacy(carr, ecount);

	vertex *dvarr = (vertex *)malloc(acount * sizeof(vertex));					//array to store all the vertices of DG
	dep_edge *dearr = (dep_edge *)malloc(acount * sizeof(dep_edge));		//array to store all the edges of DG
	construct_dg(varr, vcount, sarr, scount, aarr, acount, carr, ecount, dvarr, &dvcount, dearr, &decount, dom, dcount);

	printConflictEdgeTable(carr, ecount);
	printVariableTable(varr, vcount);
	printStatementTable(sarr, scount);
	printAccessTable(aarr, acount);
	printConflictEdgeTable(carr, ecount);
	printPathsCycles(pws, pcount, cws, ccount);
	printVertexTable(dvarr, dvcount);
	printDependenceEdgeTable(dearr, decount); 
    // generateYamlFile(varr, vcount, sarr, scount, aarr, acount, carr, ecount, dvarr, &dvcount, dearr, &decount);
    //printf("\n\n");
    //for(i=0; i<dcount; i++)
    	//printf("%s\n", dom[i]);
    
     endcputime = (double)clock();
    //printf("Time taken %lf\n", (endcputime - startcputime)/CLOCKS_PER_SEC);
        strcat(file_name, "_da.yaml");
        print_yaml_file(file_name, varr, vcount, aarr, acount, carr, ecount, sarr, scount, dom, dcount);

        int count1 = 0;		//number of wait-signal accesses
        int vcount1 = 0;		//number of variables
        int scount1 = 0;		//number of statements
	int acount1 = 0;		//number of read and write accesses
	int ecount1 = 0;		//number of conflict edges
	int dcount1 = 0;		//number of loop to statement mappings
	int pcount1 = 0;		//number of paths
	int ccount1 = 0;		//number of cycles
	int dvcount1 = 0;	//number of DG vertices
	int decount1 = 0;	//number of DG edges
        
        char file_name1[MAX], orig_file_name1[MAX];

        printf("Enter the file name : ");
        scanf("%s", file_name1);
        strcpy(orig_file_name1, file_name1);

        startcputime = (double)clock();
	char **dom1 = (char **)malloc(MAX * sizeof(char *));			//array to store loop to statement mappings
        variable *varr1 = (variable *)malloc(MAX * sizeof(variable));		//array to store all the variables
        statement *sarr1 = (statement *)malloc(MAX * sizeof(statement));		//array to store all the statements
  	parseInput(file_name1, varr1, &vcount1, sarr1, &scount1, dom1, &dcount1);


        access *aarr1 = (access *)malloc(5*scount * sizeof(access));			//array to store all the read and write accesses
	acount1 = populateAccessTable(aarr1, sarr1, scount1, dom1, varr1, vcount1);

	conf_edge *carr1 = (conf_edge *)malloc(acount1 * acount1 * sizeof(conf_edge));	//array to store all the conflict edges
	//ecount = construct_cags(aarr, acount, carr, sarr, dom, dcount);
	ecount1 = construct_cagp(varr1, aarr1, acount1, carr1, sarr1, dom1, dcount1);
	printConflictEdgeTable(carr1, ecount1);

	access *aws1 = (access *)malloc(acount1 * sizeof(access));	//array to store all the wait-signal accesses
	count1 = populateWaitSignal(aws1, sarr1, aarr1, acount1);

	conf_edge **ews1 = (conf_edge **)malloc(count1 * sizeof(conf_edge *));		//array to store all the conflict edges between wait-signal accesses
	for(i=0; i<count1; i++)
		ews1[i] = (conf_edge *)malloc(count1 * sizeof(conf_edge));

	conf_edge **fsw1 = (conf_edge **)malloc(count1 * sizeof(conf_edge *));		//array to store all the conflict edges by virtue of control flow
	for(i=0; i<count1; i++)
		fsw1[i] = (conf_edge *)malloc(count1 * sizeof(conf_edge));

	path *pws1 = (path *)malloc(MAX * sizeof(path));//array to store all the possible paths present in wait-signal subgraph
	path *cws1 = (path *)malloc(MAX * sizeof(path));//array to store all the possible cycles present in wait-signal subgraph
        
        construct_ws(aarr1, acount1, sarr1, carr1, &ecount1, aws1, count1, ews1, fsw1, dom1);

	populateReadAccess(varr1, vcount1, sarr1, aarr1, acount1, carr1, ecount1, dom1, dcount1);
	populateWriteAccess(varr1, vcount1, sarr1, aarr1, acount1, carr1, ecount1);
	findPaths(aws1, count1, sarr1, ews1, fsw1, pws1, &pcount1, cws1, &ccount1);
	undirected(aarr1, acount1, sarr1, carr1, &ecount1, pws1, pcount1, cws1, ccount1, ews1, count1, dom1);
	checkDeterminacy(carr1, ecount1);

	vertex *dvarr1 = (vertex *)malloc(acount1 * sizeof(vertex));					//array to store all the vertices of DG
	dep_edge *dearr1 = (dep_edge *)malloc(acount1 * sizeof(dep_edge));		//array to store all the edges of DG
	construct_dg(varr1, vcount1, sarr1, scount1, aarr1, acount1, carr1, ecount1, dvarr1, &dvcount1, dearr1, &decount1, dom1, dcount1);

	printConflictEdgeTable(carr1, ecount1);
	printVariableTable(varr1, vcount1);
	printStatementTable(sarr1, scount1);
	printAccessTable(aarr1, acount1);
	printConflictEdgeTable(carr1, ecount1);
	printPathsCycles(pws1, pcount1, cws1, ccount1);
	printVertexTable(dvarr1, dvcount1);
	printDependenceEdgeTable(dearr1, decount1); 

     
    // generateYamlFile(varr, vcount, sarr, scount, aarr, acount, carr, ecount, dvarr, &dvcount, dearr, &decount);
    //printf("\n\n");
    //for(i=0; i<dcount; i++)
    	//printf("%s\n", dom[i]);
    
    endcputime = (double)clock();
    strcat(file_name1, "_da.yaml");
    print_yaml_file(file_name1, varr1, vcount1, aarr1, acount1, carr1, ecount1, sarr1, scount1, dom1, dcount1);
    //printf("Time taken %lf\n", (endcputime - startcputime)/CLOCKS_PER_SEC);
//        strcat(file_name1, "_da.yaml");
 //       print_yaml_file(file_name1, varr1, vcount1, aarr1, acount1, carr1, ecount1, sarr1, scount1, dom1, dcount1);
        //printf("file1 %s file2 %s\n", file_name, file_name1);
        //strcpy(exec_str, "./eqv_check.sh ");
        //strcat(exec_str, orig_file_name);
        //strcat(exec_str, " ");
        //strcat(exec_str, orig_file_name1);
        //strcat(exec_str, "> gen_log");
        //printf("exec_str %s\n", exec_str);
        //strcpy(exec_str, "./eqv_check.sh ");

        //system(exec_str);
        //system("./eqv_check.sh inp_gen1 inp_gen2");
      //  system("./eqv_check.sh source_da.yaml target_da.yaml > gen_log");
      //  printf("LOG1 %s\n", log_file_name);
        //sprintf(exec_str, "/home/sudakshina/softwares/isa-0.12_wo_printf/isa-0.12/eqv %s %s>gen_log", file_name, file_name1);
        //sprintf(exec_str, "/home/sudakshina/softwares/isa-0.12_wo_printf/isa-0.12/eqv %s %s>gen_log", file_name, file_name1);
        //printf("exec_str %s\n", exec_str);
        //system(exec_str);
        //strcpy(log_file_name, "gen_log");
        //printf("Before generalize decount1 %d decount2 %d\n", decount, decount1);
        //generalize(log_file_name, dvarr, dvcount, dvarr1, dvcount1, dearr, decount, dearr1, decount1, varr, vcount, sarr, scount, aarr, acount); 
    /*free(dom);
    free(varr);
    free(sarr);
    free(aarr);
    free(carr);
    free(dvarr);
    free(dearr);
    free(aws);
    free(ews);
    free(fsw);
    free(pws);
    free(cws);
  */
}

/*main function*/
/*void main()
{
    char file1[MAX], file2[MAX], exec_str[5*MAX], log_file_name[5*MAX];
    vertex *dvarr1, *dvarr2;					//array to store all the vertices of DG
    int dvcount1, dvcount2, acount1, acount2;
    dvarr1 = (vertex *)malloc(acount1 * sizeof(vertex));					//array to store all the vertices of DG
    generate_dg(file1);
    
    dvarr2 = (vertex *)malloc(acount2 * sizeof(vertex));					//array to store all the vertices of DG
    generate_dg(file2);
*/
/*
    strcat(file1, "_da.yaml");
    strcat(file2, "_da.yaml");
    printf("file1 %s file2 %s\n", file1, file2);
    strcpy(exec_str, "./eqv_check.sh ");
    strcat(exec_str, file1);
    strcat(exec_str, " ");
    strcat(exec_str, file2);
    system(exec_str);
    strcpy(log_file_name, "log");
    generalize(log_file_name, dvarr1, dvcount1); */
//}
