#include "head.h"

//This function finds mapping corresponding to given domain; finds from loop to statement mapping
/* iter = names of all the iterators, lcount = loop count, str = array containing expressions (like i+4, j-1) for each of the accesses, dcount = count of all the mappings kept in dom, s1 = access numers (s1 = l for lhs, some integer for rhs, s2 = either W or S, j = number of accesses in RHS)*/
void isccMapping(variable *varr, int vcount, statement *sarr, int idx, int ind, char *s, char *iter, int lcount, char **str, char **dom, int *dcount, char *s1, char *s2, int j)
{
	int i, r;
	char it[2];
	char temp[3*MAX];

	for(i=0; i<vcount; i++)
		if(strstr(str[j-1], varr[i].n))
                {
			r = varr[i].r;
                        break;
                }

	memset(temp, '\0', sizeof(temp));
	strcat(temp, s);

	if(ind == 0)
		strcat(temp, s1);
	else
		strcat(temp, s2);
	strcat(temp, " := { [");
        //printf("temp1 %s\n sarr[idx].d %d", temp, sarr[idx].d);

	if(sarr[idx].d != 0)
	{
		for(i=0; i<lcount; i++)
		{
			sprintf(it, "%c", iter[i]);
			strcat(temp, it);
			if(i != lcount-1)
				strcat(temp, "][");
		}
	}
	else
	{
		for(i=0; i<r; i++)
		{
			strcat(temp, str[i+j]);
			if(i != r-1)
				strcat(temp, "][");
		}
	}
	strcat(temp, "] -> [");

	for(i=0; i<r; i++)
	{
		strcat(temp, str[i+j]);
		if(i != r-1)
			strcat(temp, "][");
	}
	strcat(temp, "]");
	
        if(sarr[idx].lis != 0)
        {
	    strcat(temp, " : ");
	    strcat(temp, sarr[idx].D);
        }
	strcat(temp, " };");

	dom[*dcount] = (char *)malloc(2*MAX * sizeof(char));
	strcpy(dom[*dcount], temp);
	(*dcount)++;
}

//This function performs Composition of two mappings corresponding access a1 and access a2 and the composed output is kept in temp
// This function creates a string with which fileHandling is called to generate the output of ISCC
void isccComposition(access *aarr, int acount, access a1, access a2, char *temp, char **dom)
{
	int k;
	for(k=0; k<acount; k++)
		if(strcmp(a2.s, aarr[k].s) == 0)
			break;
	strcpy(temp, dom[k]);

	for(k=0; k<acount; k++)
		if(strcmp(a1.s, aarr[k].s) == 0)
			break;
	strcat(temp, dom[k]);

	strcat(temp, a2.s);
	strcat(temp, "I := ");
	strcat(temp, a2.s);
	strcat(temp, "^-1;M := ");
	strcat(temp, a2.s);
	strcat(temp, "I( ");
	strcat(temp, a1.s);
	strcat(temp, " );M;");
}

//This function performs Intersection or Subtraction depending on operator op
void isccInterSub(char *temp, char *str1, char *str2, char *op)
{
	strcpy(temp, "S1 := ");
	strcat(temp, str1);
	strcat(temp, ";S2 := ");
	strcat(temp, str2);
	strcat(temp, ";S := S1 ");
	strcat(temp, op);
	strcat(temp, " S2;S;");
}

//This function finds domain corresponding to given mapping
void isccDomain(char *temp, char *str)
{
	strcpy(temp, "M := ");
	strcat(temp, str);
	// strcat(temp, ";S := ran M;S;");
	strcat(temp, ";S := dom M;S;");
}

/*This function performs iscc operation on command written in input file and
generates ouput in an output file and it returns the output in the string str*/
void fileHandling(char *str)
{
	char line[3*MAX];
	char *tok = NULL;
	FILE *fp;

	fp = fopen("ip.txt", "w");
	fprintf(fp, "%s", str);
	fclose(fp);

	//system("/home/sudakshina/Phd_work/softwares/isa-0.12_back/bin/iscc < ip.txt > op.txt");
	system("/home/sudakshina/softwares/isa-0.12_wo_printf/isa-0.12/bin/iscc < ip.txt > op.txt");

	fp = fopen("op.txt", "r");
	fgets(line, 2*MAX, fp);
	tok = strtok(line, "\n");
	strcpy(str, line);
	fclose(fp);
}

//This function parses the mapping to obtain association rule
void parse(char *str, char *tem, int ind)
{
	int k = 0;
	char temp[2*MAX];
	char *tok = NULL;
	char **arg = (char **)malloc(MIN * sizeof(char *));

	strcpy(temp, tem);
	tok = strtok(temp, ":");
	while(tok != NULL)
	{
		arg[k] = (char *)malloc(MAX * sizeof(char));
		strcpy(arg[k], tok);
		tok = strtok(NULL, ":");
		k++;
	}

	if(ind == 0)
	{
		tok = strtok(arg[0], "{");
		strcpy(str, tok);
	}
	else
	{
		tok = strtok(arg[k-1], "};");
		strcpy(str, arg[k-1]);
	}
}

void remove0(char *str)
{
	int j = 0;
	if(strstr(str, "0"))
	{
		while(str[j])
		{
			if(str[j] == '0')
				str[j] = ' ';
			j++;
		}
	}
}

//This function prints the variable table
void printVariableTable(variable *varr, int vcount)
{
	printf("\n****************Variable Table****************\n");
	printf("\nType\tName\tDim\tio\n");
	
	int i;
	for(i=0; i<vcount; i++)
	{
		if(varr[i].t == 0)
			printf("scalar\t%s\t%d\t%d\n", varr[i].n, varr[i].r, varr[i].io);
		else
			printf("vector\t%s\t%d\t%d\n", varr[i].n, varr[i].r, varr[i].io);
	}
}

//This function finds the height of the expression tree
int findHeight(expTreeNode *root)
{
    if(root == NULL)
        return 0;

	int i, currHeight, maxHeight = 0;
	for(i=0; i<(root -> r); i++)
	{
		currHeight = findHeight(root -> P[i]);		
		if(maxHeight < currHeight)
			maxHeight = currHeight;
	}

	return (1 + maxHeight);
}

//This function prints the nodes present at a particular level in the tree
void printLevel(expTreeNode *root, int level)
{
    if(root == NULL)
        return;

    if(level == 1)
        printf("\n\t\t%s : %d children", root -> n, root -> r);
    else
    {
        int i;
		for(i=0; i<(root -> r); i++)
			printLevel(root -> P[i], level-1);
    }
}

//This function finds the level order traversal of the expression tree
void levelorder(expTreeNode *root)
{
    if(root == NULL)
        return;

    int i;
    int n = findHeight(root);
    for(i=1; i<=n; i++)
	{
		printf("\nLevel %d : --------", i);
        printLevel(root, i);
	}
}

//This function prints the statement table
void printStatementTable(statement *sarr, int scount)
{
	printf("\n****************Statement Table****************\n");	
	
	int i, j;
	for(i=0; i<scount; i++)
	{
		printf("\nLevel Order Traversal of L for statement %d:\n", i+1);
		if(sarr[i].L)
			levelorder(sarr[i].L -> P);
		printf("\n\n");

		printf("\nLevel Order Traversal of S for statement %d:\n", i+1);
		levelorder(sarr[i].T);
		printf("\n\n");

		printf("type\tvertex\tLoop Depth\tLoopno\tFlag\t\tDomain\n");
		printf("%d\t%s\t\t%d\t%d\t", sarr[i].t, sarr[i].v.f, sarr[i].d, sarr[i].lis);

		for(j=0; j<sarr[i].d; j++)
			printf("%d ", sarr[i].o[j]);
		printf("\t%s\n", sarr[i].D);
	}
}

//This function populates all the accesses present in the program
void printAccessTable(access *aarr, int acount)
{
	printf("\n****************Access Table****************\n");
	printf("\nStmt\tType\tLoc\tRange\t\t\t\t\t\t\tOrdered Pair\n");

	int i, j;
	for(i=0; i<acount; i++)
	{
		printf("%s\t", aarr[i].s);
		if(aarr[i].t == 0)
			printf("%s\t", "rd");
		else
			printf("%s\t", "wt");
		printf("%s\t%s\t", aarr[i].r -> n, aarr[i].R);

		if(aarr[i].S != NULL)
		{
			j = 0;
			while(aarr[i].S[j].s[0] != '\0')
			{
				printf("(%s,%s)", aarr[i].S[j].s, aarr[i].S[j].D);
				j++;
			}
		}
		printf("\n");
	}
}

//This function prints all the conflict accesses present in the program
void printConflictEdgeTable(conf_edge *carr, int ecount)
{
	printf("\n****************Conflict Edge Table****************\n");
        printf("Number of edges : %d\n", ecount);
	printf("\nA1\tA2\tType\tMapping\n");

	int i;
	for(i=0; i<ecount; i++)
	{
		//if(carr[i].flag == 1 && strcmp(carr[i].M, "{  }") != 0)
		if(strcmp(carr[i].M, "{  }") != 0)
		{
			printf("%s\t%s\t", carr[i].a1.s, carr[i].a2.s);
			if(carr[i].t == 0)
				printf("%s\t", "RAW");
			else if(carr[i].t == 1)
				printf("%s\t", "WAR");
			else if(carr[i].t == 2)
				printf("%s\t", "WAW");
			printf("%s\n", carr[i].M);
		}
	}
}

//This function prints all the paths and cycles present in wait-signal subgraph
void printPathsCycles(path *pws, int pcount, path *cws, int ccount)
{
	printf("\n****************PATHS****************\n");

	int i, j;
	for(i=0; i<pcount; i++)
	{
		j = 0;
		while(pws[i].P[j].s[0] == 'S')
		{
			printf("%s ", pws[i].P[j].s);
			j++;
		}
		printf("\nmapping - %s\n", pws[i].M);
	}

	printf("\n****************CYCLES****************\n");

	for(i=0; i<ccount; i++)
	{
		j = 0;
		while(cws[i].P[j].s[0] == 'S')
		{
			printf("%s ", cws[i].P[j].s);
			j++;
		}
		printf("\nmapping - %s\n", cws[i].M);
	}
}

//This function prints all the vertices present in the dependence graph
void printVertexTable(vertex *dvarr, int dvcount)
{
	printf("\n****************Vertex Table****************\n");
	printf("\nSt\tName\tDim\tLoop Depth\tDomain\n");

	int i;
	for(i=0; i<dvcount; i++)
            if(dvarr[i].s[0] == 'S')
		printf("%s\t%s\t%d\t\t%d\t{ %s }\n", dvarr[i].s, dvarr[i].f, dvarr[i].r, dvarr[i].d, dvarr[i].D);
            else
		printf("%s\t%s\t%d\t\t%d\t%s\n", dvarr[i].s, dvarr[i].f, dvarr[i].r, dvarr[i].d, dvarr[i].D);
           
}

//This function prints all the dependence edges present in the dependence graph
void printDependenceEdgeTable(dep_edge *dearr, int decount)
{
	printf("\n****************Dependence Edge Table****************\n");
	printf("\nSrc\tTar\tpos\tMapping\n");

	int i;
	for(i=0; i<decount; i++)
		if(strcmp(dearr[i].M, "") != 0)
			printf("%s,%s\t%s,%s\t%d\t%s\n", dearr[i].s.s, dearr[i].s.f, dearr[i].t.s, dearr[i].t.f, dearr[i].p, dearr[i].M);
}
